package com.blackledge.david.html;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class HTMLFormInput extends HTMLFormField {

	private HashMap<String, String> attributes = new HashMap<String, String>();

	public HTMLFormInput(String form,  HashMap<String, String> a, Object textFont, boolean isBold, boolean isItalic, int textSize) {
		super(form, getAttribute(a, "name"), getAttribute(a, "type"), textFont, isBold, isItalic, textSize);
		attributes.putAll(a);
		this.disabled = (attributes.get("disabled") != null);
	}
	
	@Override
	public List<? extends String[]> getSubmissions() {
		ArrayList<String[]> submissions = new ArrayList<String[]>();
		if(!this.disabled) {
			if(this.type == null ) {
				if(this.name != null)
				submissions.add(new String[] {this.name, this.getAttribute("value")});
			} else
			if (this.type.equals("checkbox") || this.type.equals("radio")) {
				if (this.getAttribute("checked") != null) {
					if(this.name != null)
					submissions.add(new String[] {this.name, this.getAttribute("value")});
				}
			} else if (this.type.equals("button") || this.type.equals("submit")
					|| this.type.equals("image")) {
				return submissions;
			} else {
				if(this.name != null)
				submissions.add(new String[] {this.name, this.getAttribute("value")});
			}
		}
		return submissions;
	}
	
	public String getAttribute(String attName) {
		return attributes.get(attName);
	}
	
	private static String getAttribute(HashMap<String, String> attributes, String attName) {
		return attributes.get(attName);
//		Enumeration<?> atts = attributes.getAttributeNames();
//		while (atts.hasMoreElements()) {
//			Object key = atts.nextElement();
//			if (key.toString().equalsIgnoreCase(attName)) {
//				Object val = attributes.getAttribute(key);
//				if (val != null)
//					return String.valueOf(val);
//				else 
//					return null;
//			}
//		}
//		return null;
	}

	public String putAttribute(String key, String value) {
		return attributes.put(key, value);
	}

	public void removeAttribute(String key) {
		attributes.remove(key);
	}

}
