package com.blackledge.david.html;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class HTMLFormTextarea extends HTMLFormField {

	public String contents;
	private String cols;
	private String rows;
	private HashMap<String, String> attributes = new HashMap<String, String>();

	public HTMLFormTextarea(String name, String contents, String formSpec, HashMap<String, String> a, Object textFont,
			boolean isBold, boolean isItalic, int textSize) {
		super(formSpec, name.substring(0,name.indexOf("|")), "textarea", textFont, isBold, isItalic, textSize);
		attributes.putAll(a);
		this.disabled = (attributes.get("disabled") != null);
		
		this.contents = contents;
		String size = name.substring(name.indexOf("|")+1);
		this.cols = size.substring(0, size.indexOf("x"));
		this.rows = size.substring(size.indexOf("x")+1);
		
	}
	
	@Override
	public List<? extends String[]> getSubmissions() {
		ArrayList<String[]> submissions = new ArrayList<String[]>();
		if(!this.disabled) {
			if(this.name != null)
			submissions.add(new String[] {this.name, this.contents});
		}
		return submissions;
	}
 
	public String getCols() {
		return cols;
	}
	
	public String getRows() {
		return rows;
	}
}
