package com.blackledge.david.html;

import java.awt.Color;

public class HTMLTextChunk extends HTMLStyleChunk {

	public boolean isContinuation;
	public String text;
	public String link;
	public String anchor;
	public Color bgcolor;
	public String bg;
	public int bgposition;
	public int bgrepeat;
	
	@Override
	public String toString() {
		if (this.link != null) {
			return"[" + this.text + "]";
		} else {
			return this.text;
		}
	}

	public HTMLTextChunk(String text, Object font, boolean isBold,
			boolean isItalic, int fontSize, Color color, Color bgcolor, int bgposition, int bgrepeat, String bg,
			String link, boolean isContinuation, boolean localColor) {
		this.isLocalColor = localColor;
		this.chunkType = ChunkType.TEXT;
		this.text = text;
		this.font = font;
		this.isBold = isBold;
		this.isItalic = isItalic;
		this.fontSize = fontSize;
		this.color = color;
		this.bgcolor = bgcolor;
		this.bgposition = bgposition;
		this.bgrepeat = bgrepeat;
		this.bg = bg;
		if(link != null && link.indexOf("\t")>=0) {
			this.link = link.substring(link.indexOf("\t")+1);
			this.anchor = link.substring(0,link.indexOf("\t"));
			if(this.anchor.length() == 0) this.anchor = null;
			if(this.link.length() == 0) this.link = null;
		} else {
			this.link = link;
		}
//if(this.anchor != null) 
//	System.out.println("STORED anchor:"+this.anchor);
		this.isContinuation = isContinuation;
	}

	public boolean sameStyleAs(HTMLTextChunk otherChunk) {
		return equal(this.font, otherChunk.font)
				&& this.isBold == otherChunk.isBold
				&& this.isItalic == otherChunk.isItalic
				&& this.fontSize == otherChunk.fontSize
				&& equal(this.color, otherChunk.color)
				&& equal(this.isLocalColor, otherChunk.isLocalColor)
				&& equal(this.link, otherChunk.link);
		
	}

	private boolean equal(Object a, Object b) {
		if (a == null)
			return b == null;
		if (b == null)
			return false;
		return a.equals(b);
	}
}
