package com.blackledge.david.html.hme;

import java.awt.Color;

import com.tivo.hme.bananas.BEvent;
import com.tivo.hme.bananas.BHighlights;
import com.tivo.hme.bananas.BSkin.Element;
import com.tivo.hme.bananas.BView;

public class FormButton extends BView {

	private Object form;
	private String name;
	private Object action;
	private BView label;

	public FormButton(Object object, String name, BView parent, int x, int y, int width, int height) {
		// +(width%2==1?1:0):  to adjust evenness of width to prevent overlap of left/right halves
		super(parent, x, y, getWidth(width, ((WebBrowserApp)parent.getBApp()).getTheme())
				, getHeight(height, ((WebBrowserApp)parent.getBApp()).getTheme()));
		this.name = name;
		init(object);
	}

	public static int getHeight(int height, WebBrowserTheme theme) {
		return height+theme.getFormOffsets(WebBrowserTheme.FORM.BUTTON)[1];
//				10;
	}

	public static int getWidth(int width, WebBrowserTheme theme) {
		return width+theme.getFormOffsets(WebBrowserTheme.FORM.BUTTON)[0]
//				20
//				+(width%2==1?1:0)
;
	} 
	
	 void updateButton(String value, Color labelColor, String fontString) {
// System.out.println("updateButton "+value);
		 createLabel();
		 if(labelColor == null) labelColor = Color.white;
		 label.setResource(label.createText(fontString, labelColor, value));
	}

	private void createLabel() {
		if(label == null) {
			int[] offsets = ((WebBrowserApp)getBApp()).getTheme().getFormLabelOffsets(WebBrowserTheme.FORM.BUTTON);
			label = new BView(this, offsets[0], offsets[1], getWidth()+offsets[2], getHeight()+offsets[3]);
//					10, 5, getWidth()-20, getHeight()-10);
		}
	}

	private void init(Object form) {
		this.form = form;
		
		BView barLeft = new BView(this, 0, 0, this.getWidth()/2, this.getHeight());
		//NOTE 1 pixel gap on simulator, but otherwise 1 pixel overlap on TiVo
		BView barRight = new BView(this, this.getWidth()/2
//				/**/+1
				, 0, this.getWidth()-this.getWidth()/2, this.getHeight());
		barLeft.setResource(((WebBrowserApp)getBApp()).getTheme().getFormResource(WebBrowserTheme.FORM.BUTTON), RSRC_HALIGN_LEFT| RSRC_VALIGN_CENTER|RSRC_IMAGE_VFIT);
		barRight.setResource(((WebBrowserApp)getBApp()).getTheme().getFormResource(WebBrowserTheme.FORM.BUTTON), RSRC_HALIGN_RIGHT| RSRC_VALIGN_CENTER|RSRC_IMAGE_VFIT);
		
		setFocusable(true);
		int[] offsets = ((WebBrowserApp)getBApp()).getTheme().getFormOffsets(WebBrowserTheme.FORM.BUTTON);
		getHighlights().setWhisperingArrow(BHighlights.H_RIGHT,
				BHighlights.A_RIGHT+offsets[2],
				BHighlights.A_CENTER, "right");
		getHighlights().setWhisperingArrow(BHighlights.H_LEFT,
				BHighlights.A_LEFT+offsets[3],  
				BHighlights.A_CENTER, "left");
		getHighlights().setWhisperingArrow(BHighlights.H_UP,
				 BHighlights.A_CENTER, 
				 BHighlights.A_TOP+offsets[4], "up");
		getHighlights().setWhisperingArrow(BHighlights.H_DOWN,
				 BHighlights.A_CENTER, 
				 BHighlights.A_BOTTOM+offsets[5], "down");
		getHighlights().setVisible(BHighlights.H_RIGHT, BHighlights.H_VIS_FALSE);
		getHighlights().setVisible(BHighlights.H_LEFT, BHighlights.H_VIS_FALSE);
		getHighlights().setVisible(BHighlights.H_UP, BHighlights.H_VIS_FALSE);
		getHighlights().setVisible(BHighlights.H_DOWN, BHighlights.H_VIS_FALSE);
	}

	public Object getForm() {
		return form;
	}
	
	public String getName() {
		return name;
	}
	
	@Override
	public boolean handleKeyPress(int code, long rawcode) {
		if(code == KEY_SELECT) {
			postEvent(new BEvent.Action(this, getAction()));
			return true;
		} else {
			return super.handleKeyPress(code, rawcode);
		}
	}

	private Object getAction() {
		return this.action;
	}
	
	public void setAction(Object action) {
		this.action = action;
	}
	
}
