<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"  
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    exclude-result-prefixes="xsl dc"
>
<!--  TiVoConnect web page formatter by david.blackledge.com -->

<xsl:output method="html"/>

<xsl:param name="pHost" select="substring-before(substring-after(TiVoContainer/Item/Links/Content/Url,'://'), '/')"/>
<xsl:variable name="maxitems" select="1000" />

<xsl:template match="/">
<!-- 
<LINK rel="shortcut icon" href="http://feedicons.com/images/feed-icon-28x28.png" type="image/png"/>
-->
<TITLE><xsl:value-of select="TiVoContainer/Details/Title"/></TITLE>
<BODY bgcolor="#000077" color="#9999FF" link="#FFFFFF">
  <xsl:if test="TiVoContainer/Item">
  <h1><xsl:value-of select="TiVoContainer/Details/Title"/></h1>
  <small><i>Note that some apps won't launch without additional information, and generally Flash apps won't work unless they have special configuration</i></small>
  	<hr/>
  	<div class="items">
      <xsl:apply-templates select="TiVoContainer/Item[position() &lt; number($maxitems)+1]"/>
  	</div>
  </xsl:if>
</BODY>  
</xsl:template>


<xsl:template match="Item">
    <xsl:call-template name="drawItem">
		<xsl:with-param name="item_link"
			select="substring-after(substring-after(Links/Content/Url,'://'), '/')" />
        <xsl:with-param name="item_title" select="Details/Title" />
        <xsl:with-param name="item_icon" select="Links/CustomIcon/Url" />
        <xsl:with-param name="item_uuid" select="Details/Uuid" />
        <xsl:with-param name="item_type" select="Details/ContentType" />
    </xsl:call-template>
	<xsl:apply-templates select="Details/Hidden"/>
	<xsl:apply-templates select="Genres/Genre"/>
<BR/>
</xsl:template>

<xsl:template match="Genre">
    	| <xsl:value-of select="text()"/> |
</xsl:template>

<xsl:template match="Hidden">
(hidden)
</xsl:template>


<xsl:template name="drawItem">
    <xsl:param name="item_link" />
    <xsl:param name="item_title" />
    <xsl:param name="item_icon" />
    <xsl:param name="item_uuid" />
    <xsl:param name="item_type" />    
  	<a href="hme://{$pHost}/{$item_link}"><img width="32" height="32" src="{$item_icon}"/> <xsl:value-of select="$item_title"/></a>
	    <!-- <font size="1">uuid:<xsl:value-of select="$item_uuid"/></font> -->
	    <font size="1"> - <xsl:value-of select="$item_type"/></font> 
</xsl:template>
</xsl:stylesheet>

