package com.blackledge.david.html.hme;

import java.awt.Color;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.Date;
import java.util.List;
import java.util.Map;

import com.blackledge.david.tivo.TiVo;
//import com.blackledge.david.tivo.Utility;

import com.tivo.hme.bananas.BEvent;
import com.tivo.hme.bananas.BText;
import com.tivo.hme.bananas.BView;

import com.tivo.hme.sdk.HmeEvent;
import com.tivo.hme.sdk.Resource;
import com.tivo.hme.sdk.StreamResource;
import com.tivo.hme.sdk.HmeEvent.ResourceInfo;
import com.tivo.hme.sdk.util.Ticker;
import com.tivo.hme.sdk.util.Ticker.Client;

/**
 * A view for displaying/controlling a video stream
 * @deprecated
 * @version $Revision: 1.5 $
 */
public class VideoView extends BView {
    public class TextTrickPlayBar extends BText implements TrickPlayView {

        public TextTrickPlayBar(BView parent, int x, int y, int width, int height, boolean visible) {
            super( parent, x, y, width, height, visible );
//            new BText(this, SAFE_TITLE_H, getHeight()-SAFE_TITLE_V-20, 
//                    getWidth()-2*SAFE_TITLE_H, 20, true);
            setShadow( true );
            setColor( Color.white );
            setFont( "default-20.font" );
        }

        public void update(long videoPosition, long videoDuration, boolean videoDownloaded,
                int videoStatus, double videoSpeed, String errorCode, String errorMess) {
            String text = "";

//          if(videoStatus >= RSRC_STATUS_READY && videoStatus <= RSRC_STATUS_COMPLETE) {
              if(videoPosition > -1 && videoDuration > 0) {
                  text += (videoPosition*100)/videoDuration+"% of ";
                  text += (videoDuration/(1000*60)) + " mins";
              }
              if(!videoDownloaded) {
                  // a little in-progress animation.
                  switch(((int)(videoDuration % 4))) {
                  case 0: text += " (|)"; break;
                  case 1: text += " (/)"; break;
                  case 2: text += " (-)"; break;
                  case 3: text += " (\\)"; break;
                  }
//                text += " +";
              }
              if(videoSpeed > speed_normal) {
                  text += " >>";
                  if(videoSpeed > speed_forward1)
                      text += " >";
                  if(videoSpeed > speed_forward2)
                      text += " >";
              } else if(videoSpeed > speed_paused && videoSpeed < speed_normal) {
                  text += " S>";
              } else if (videoSpeed < speed_paused) {
                  text += " <<";
                  if(videoSpeed < speed_reverse1)
                      text += " <";
                  if(videoSpeed < speed_reverse2)
                      text += " <";
              } else if (videoSpeed == speed_paused && 
                      (videoStatus == RSRC_STATUS_PAUSED || videoStatus == RSRC_STATUS_BUFFER_OVERFLOW)) {
                  text += " ||";
              } else if (videoSpeed == speed_normal) {
                  text += " >";
              }

//          } 
          if(videoStatus == RSRC_STATUS_ERROR){
              // try to make errorCode nicer.
              errorCode = VideoView.getResourceErrorCodeText( errorCode );
              text += " error "+errorCode+" / "+errorMess;
          } else if(videoStatus <= RSRC_STATUS_READY){
              text += " loading..."+"....".substring(RSRC_STATUS_READY-videoStatus);
          } else if(videoStatus == RSRC_STATUS_END) {
            text += " (End)";
          } else if(videoStatus == RSRC_STATUS_BUFFER_OVERFLOW) {
            text += " (loading - press play in a moment)";
          } else if(videoStatus > RSRC_STATUS_BUFFER_OVERFLOW ||
                  videoStatus <= RSRC_STATUS_UNKNOWN){
//              if(endOfStream) {
//                  if(videoDownloaded) {
//                      text += " (End)";
//                  } else {
//                      text += " (loading - press play in a moment)";
//                  }
//              } else {
                  text += " ??? "+videoStatus;
//              }
          }

          setValue( text );
        }


        public void reset(int expectedDuration) {
            // TODO Auto-generated method stub
            
        }


    }

    public interface TrickPlayView {

        void setVisible(boolean b);

        boolean getVisible();

        void update(long videoPosition, long videoDuration, boolean videoDownloaded,
                int videoStatus, double videoSpeed, String errorCode, String errorMess);

        public void reset(int expectedDuration);

    }

    public static String getResourceErrorCodeText(String errorCodeNum) {
        if(errorCodeNum != null) {
              try {
                  int erCode = Integer.parseInt(errorCodeNum);
                  switch(erCode) {
                  case RSRC_ERROR_BAD_ARGUMENT:
                  case RSRC_ERROR_BAD_DATA:
                  case RSRC_ERROR_BAD_MAGIC:
                  case RSRC_ERROR_BAD_STATE:
                  case RSRC_ERROR_BAD_VERSION:
                      errorCodeNum = "Software Error "+erCode;
                      break;
                  case RSRC_ERROR_CONNECT_FAILED:
                      errorCodeNum = "Connection Failed";
                      break;
                  case RSRC_ERROR_CONNECTION_LOST:
                      errorCodeNum = "Connection Lost";
                      break;
                  case RSRC_ERROR_CONNECTION_TIMEOUT:
                      errorCodeNum = "Connection Timed Out";
                      break;
                  case RSRC_ERROR_HOST_NOT_FOUND:
                      errorCodeNum = "Host Not Found Error";
                      break;
                  case RSRC_ERROR_INCOMPATIBLE:
                      errorCodeNum = "Error - incompatible";
                      break;
                  case RSRC_ERROR_NOT_SUPPORTED:
                      errorCodeNum = "Error - not supported";
                      break;
                  case RSRC_ERROR_OTHER:
                      errorCodeNum = "General Error";
                      break;
                  case RSRC_ERROR_UNKNOWN:
                      errorCodeNum = "Unknown Error";
                      break;
                  }
              } catch(NumberFormatException e) {
              }
              //TODO getting errorCode 11 with 404 HTTP errors...maybe 11 = http error.
          }
        return errorCodeNum;
    }

    /** Media status code, resource at end of stream. */
    public static final int RSRC_STATUS_END = 11;
    /** Media status code, resource at end of available buffer. */
    public static final int RSRC_STATUS_BUFFER_OVERFLOW = 12;

    /**
     * Ticker Client to hide the TrickPlay after a while.
     *
     * @version $Revision: 1.5 $
     */
    public class HideTrickPlayClient implements Client {

        public long tick(long tm, Object arg) {
            hideTrickPlayClient = null;
            hideTrickPlayBar();
            return 0;
        }

    }
    private StreamResource videoStream = null;
    private int videoStatus = RSRC_STATUS_UNKNOWN;
    private long videoPosition = -1;
    private long videoDuration = -1;
    private double videoSpeed = 0;
    private long videoStart = -1;
    private String videoSpan = null;
    private TrickPlayView trickPlayBar;

    public VideoView(BView parent, String url) {
        super( parent, parent.getX(), parent.getY(), parent.getWidth(), parent.getHeight() );
        setFocusable( true );
        trickPlayBar = createTrickPlayBar();
        initVideo(url);
        if(videoStream == null) {
            trickPlayBar.update( 0, 0, false, 0, 0.0, "unsupported video stream", null );
        }
    }
    public VideoView(BView parent) {
        super( parent, parent.getX(), parent.getY(), parent.getWidth(), parent.getHeight() );
        setFocusable( true );
        trickPlayBar = createTrickPlayBar();
        if(videoStream == null) {
            trickPlayBar.update( 0, 0, false, 0, 0.0, "unsupported video stream", null );
        }
    }

    int index = -1;
    HideTrickPlayClient hideTrickPlayClient;
    private String errorMess;
    private String errorCode;
    private boolean endOfStream = false;
    private boolean videoDownloaded = false;
    private long rangeStart = -1;
    
    public void setRangeStart(long byteOffset) {
        this.rangeStart = byteOffset;
    }
    
    private StreamResource initVideo(String urlString, String type) {
        return initVideo(urlString, type, -1);
    }
    private StreamResource initVideo(String urlString, String type, int expectedDuration) {
        videoDownloaded  = false;
        endOfStream = false;

        trickPlayBar.reset( expectedDuration );
        
        if(type == null) {
            String urlLower = urlString.toLowerCase();
            //TODO this is a bit hacked together.
            if( urlLower.indexOf( ".mp4" ) > -1 || urlLower.indexOf( ".mov" ) > -1 ) {
                type = "video/mp4";
            } else if( urlLower.indexOf( ".mpeg" ) > -1 || urlLower.indexOf( ".mpg" ) > -1
                       || urlLower.indexOf( ".tivo" ) > -1 ) {
                type = "video/mpeg";
            }
        }
        if(type != null && type.startsWith("video/")) {
            if(type.indexOf("4")>-1 ||
                    //.mov files usually come in as quicktime but they may be mp4's
                    type.toLowerCase().indexOf("quicktime") > -1
                    ) {
                type = "video/mp4"; // mpeg 4
            } else {
                type = "video/mpeg"; // mpeg 2
            }
            
            videoStream = createStream( 
                    urlString, 
                    type,
                    true
            );
            //              type = "video/x-tivo-raw-tts";// theoretical .tivo file support
            setResource( 
                    videoStream
            );
//            // make the stream the active resource so it can automatically respond to some events, perhaps.
//            videoStream.setActive( true );
            
            setFocus();
            setVisible( true );
            return videoStream;
        }
        videoStream = null;
        setVisible( true );
        return null;
    }
    
    private void initVideo(String urlString) {
        //this isn't necessary for the "systm" podcast at least even though it does redirect.
//        urlString = Utility.handleRedirect( urlString );
//        List urls = Utility.handleMultiStreamSource( urlString );
//        if(urls == null || urls.size() < 1) {
//            // don't change url;
//        } else {
//            index = 0;
//        }

        boolean tryingUrls = true;
        while(tryingUrls 
//        		&& index < urls.size()
        		) {

            if(index == -1) tryingUrls = false;
//            else {
//                urlString = (String)urls.get( index );
//                ++index;
//                urlString = Utility.handleRedirect( urlString );
//            }


            try {
                URL url = new URL(urlString);
                URLConnection con = url.openConnection();
// This makes no sense as this connection request isn't used in the final stream creation.                
//                if(rangeStart > 0) {
//                    String range = "bytes="+rangeStart+"-"+rangeEnd;
//                    // based on "Range: bytes=0-" seen during MRV session.
//                    con.setRequestProperty( "Range", range );
//                    System.out.println("range set to "+range);
//                }
                String type = con.getContentType();
                StreamResource createdStream = initVideo(urlString, type);
                if(createdStream != null) {
                    tryingUrls = false;
                }
            } catch(MalformedURLException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            } catch(IOException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
            
        }
        
        
    }
    

    public boolean handleEvent(HmeEvent event) {
        if(event instanceof HmeEvent.ResourceInfo) {
            ResourceInfo resInf = (ResourceInfo) event;
            // Status changes only
            if(resInf.getOpCode() == Resource.EVT_RSRC_STATUS) {
                if(resInf.getStatus() == RSRC_STATUS_READY) {
                    // start the timeout automatically now that we're ready.
                    showTrickPlayBarBriefly();
                }
            }
            // full info (fires before(?) status event)
            else if(resInf.getResource() == videoStream) {
                // transition from pause to unknown indicates we hit the end of the stream.
                //do we also get this when it reaches its natural conclusion?  Handling, just in case.
                
                videoStatus = resInf.getStatus();
                Map resMap = resInf.getMap();
                if(resMap != null) {
                    // don't overwrite error info on next event.
                    String erCod = (String)resMap.get("error.code");
                    if(erCod != null)
                        errorCode = erCod;
                    String erMes = (String)resMap.get("error.text");
                    if(erMes != null)
                        errorMess = erMes;
                    videoDuration = getLong((String)resMap.get("duration"));
                    videoPosition = getLong((String)resMap.get("position"));
                    // pos is "duration/position"
                    videoStart = getLong((String)resMap.get("start"));
                    videoSpeed = getDouble((String)resMap.get("speed"));
                    videoSpan = (String)resMap.get("span"); 
                    // span is start/end of buffered span, but at a 1/1000 scale
                    
                }

                // COMPLETE means it finished downloading, regardless of whether
                // it is finished playing.
                if(videoStatus == RSRC_STATUS_COMPLETE) {
                    videoDownloaded = true;
                }
                endOfStream = false;
                if(videoStatus == RSRC_STATUS_END || 
                        videoStatus == RSRC_STATUS_BUFFER_OVERFLOW) {
                    endOfStream = true;
                    setSpeed( speed_paused );
                    showTrickPlayBar();
                }

                updateTrickPlayBar();
                
                if(endAction != null) {
                    if(
                            videoStatus == RSRC_STATUS_ERROR || 
                            videoStatus == RSRC_STATUS_CLOSED ||
                            videoStatus == RSRC_STATUS_END
                            ) {
                        showTrickPlayBar();
                        postEvent( new BEvent.Action(this, endAction) );
                    }
                }

                //don't bogart the resource events.
//              return true;
            }
        }
        return super.handleEvent( event );
    }
    
    /**
     * 
     *
     * {@inheritDoc}
     * @see com.tivo.hme.bananas.BView#handleKeyPress(int, long)
     */
    public boolean handleKeyPress(int code, long rawcode) {
        switch(code) {
        case KEY_PAUSE:
            pause();
            return true;
        case KEY_PLAY:
            play();
            return true;
//        case KEY_FORWARD:
//            forward();
//            return true;
//        case KEY_REVERSE:
//            reverse();
//            return true;
        case KEY_CLEAR:
            clear();
            return true;
//        case KEY_ADVANCE:
//            advance();
//            return true;
//        case KEY_REPLAY:
//            replay();
//            return true;
//        case KEY_SLOW:
//            slow();
//            return true;
        }
        return super.handleKeyPress( code, rawcode );
    }

    public void showTrickPlayBarBriefly() {
        showTrickPlayBar();
        hideTrickPlayClient = new HideTrickPlayClient();
        getTicker().add(hideTrickPlayClient, new Date().getTime()+getHideTrickPlayMillis(), null);
    }
    public void showTrickPlayBar() {
        trickPlayBar.setVisible( true );
        updateTrickPlayBar();
        getApp().flush();
        if(hideTrickPlayClient != null) {
            getTicker().remove( hideTrickPlayClient, null );
        }
    }

    private Ticker ticker = null;
    private Ticker getTicker() {
        if(ticker == null)
            ticker = new Ticker("myVideoTrickBarTicker", Ticker.NORM_PRIORITY);
        return ticker;
    }
    
    public void hideTrickPlayBar() {
        trickPlayBar.setVisible( false );
    }

    private Resource trickPlayHideDelay = null;
    private Resource getTrickPlayHideDelay() {
        if(trickPlayHideDelay == null) {
            trickPlayHideDelay = createAnimation( getHideTrickPlayMillis() );
        }
        return trickPlayHideDelay;
    }

    private int getHideTrickPlayMillis() {
        return 5000;
    }

    public void setSpeed(float newSpeed) {
        videoSpeed = newSpeed; // approximate new speed.
        videoStream.setSpeed( newSpeed );
    }
    public void setPosition(long position) {
        videoPosition = position; // approximate new location.
        videoStream.setPosition( position );
    }

    public void slow() {
        if(videoSpeed == speed_slow) {
            setSpeed(speed_normal);
        } else {
            setSpeed(speed_slow);
        }
        showTrickPlayBar();
        
    }

    public void replay() {
        long pos = Math.max( 0,videoPosition - 8*1000 );
        setPosition(pos);
        play(TiVo.SOUND_SELECT);
        setSpeed( speed_normal );
        showTrickPlayBarBriefly();
    }

    public void advance() {
        if(videoSpeed > 1.0) {
            setPosition( videoDuration );
            setSpeed(speed_normal);
            play(TiVo.SOUND_SELECT);
        } else if(videoSpeed < 0) {
            setPosition( 0 );
            setSpeed(speed_normal);
            play(TiVo.SOUND_DESELECT);
        } else {// if(videoSpeed == 1.0) {
            // special case: end of movie, let them skip back to beginning.
            if(videoSpeed == 0 && videoDownloaded && endOfStream) {
                setPosition( 0 );
                // give it two speeds to wake it out of "end of movie" mode.
                setSpeed(speed_paused);
                setSpeed(speed_normal);
                play(TiVo.SOUND_SELECT);
            } else {
                // 30 second skip.
                long pos = Math.min( videoPosition + 30*1000, videoDuration );
                setPosition( pos );
                setSpeed(speed_normal);
                play(TiVo.SOUND_SELECT);
            }
        }
        showTrickPlayBarBriefly();
        
    }

    public void clear() {
        hideTrickPlayBar();
    }

    protected static final float speed_forward3 = 60.0f;
    protected static final float speed_forward2 = 18.0f;
    protected static final float speed_forward1 = 3.0f;
    protected static final float speed_slow = 0.25f;
    protected static final float speed_normal = 1.0f;
    protected static final float speed_paused = 0.0f;
    protected static final float speed_reverse1 = -3.0f;
    protected static final float speed_reverse2 = -18.0f;
    protected static final float speed_reverse3 = -60.0f;
    
    public void reverse() {
        if(videoSpeed <= speed_normal && videoSpeed > speed_paused) {
            play( TiVo.SOUND_SPEEDUP1 );
            setSpeed(speed_reverse1);
            showTrickPlayBar();
        } else if(videoSpeed == speed_reverse1){
            play( TiVo.SOUND_SPEEDUP2 );
            setSpeed(speed_reverse2);
            showTrickPlayBar();
        } else if(videoSpeed == speed_reverse2) {
            play( TiVo.SOUND_SPEEDUP3 );
            setSpeed(speed_reverse3);
            showTrickPlayBar();
        } else if(videoSpeed == speed_paused) {
            if(videoDownloaded && endOfStream) {
                // special case, just do a rewind.
                play( TiVo.SOUND_SPEEDUP1 );
                // give it two speeds to wake it out of "end of movie" mode.
                setSpeed(speed_paused);
                setSpeed(speed_reverse1);
                showTrickPlayBar();
            } else {
                frameReverse();
            }
        } else {
            if(videoSpeed == speed_forward2) {
                play( TiVo.SOUND_SPEEDUP1 );
                setSpeed(speed_forward1);
                showTrickPlayBar();
            } else if(videoSpeed > speed_forward2) {
                play( TiVo.SOUND_SPEEDUP2 );
                setSpeed(speed_forward1);
                showTrickPlayBar();
            } else {
//        } else if(speed == forward1) {
//            play( TiVo.SOUND_SLOWDOWN1 );
//            setSpeed(normal);
                play( TiVo.SOUND_SLOWDOWN1);
                setSpeed(speed_normal);
                showTrickPlayBarBriefly();
            }
        }
    }
    /**
     * 30 frames per second means 30 frames per 1000 ms means 1000/30 ms per
     * frame.
     */
    private static int FRAME_TIME = 1000/30;
    public void frameReverse() {
        if(videoPosition > 0) {
            setPosition(videoPosition - FRAME_TIME);
        }
        showTrickPlayBarBriefly();
    }
    public void frameForward() {
        if(!(videoDownloaded && endOfStream)) {
            setPosition(videoPosition + FRAME_TIME);
        }
        showTrickPlayBarBriefly();
    }

    public void forward() {
        if(videoSpeed == speed_normal) {
            play( TiVo.SOUND_SPEEDUP1 );
            setSpeed(speed_forward1);
            showTrickPlayBar();
        } else if(videoSpeed == speed_forward1){
            play( TiVo.SOUND_SPEEDUP2 );
            setSpeed(speed_forward2);
            showTrickPlayBar();
        } else if(videoSpeed == speed_forward2){
            play( TiVo.SOUND_SPEEDUP3 );
            setSpeed(speed_forward3);
            showTrickPlayBar();
        } else if(videoSpeed == speed_paused) {
            frameForward();
        } else if(videoSpeed == speed_reverse1) {
            play( TiVo.SOUND_SLOWDOWN1 );
            setSpeed(speed_normal);
            showTrickPlayBarBriefly();
        } else if(videoSpeed == speed_reverse2){
            play( TiVo.SOUND_SPEEDUP1 );
            setSpeed(speed_reverse1);
            showTrickPlayBar();
        } else if(videoSpeed == speed_reverse3){
            play( TiVo.SOUND_SPEEDUP2 );
            setSpeed(speed_reverse2);
            showTrickPlayBar();
        } else {
            play( TiVo.SOUND_SLOWDOWN1);
            setSpeed(speed_normal);
            showTrickPlayBarBriefly();
        }
    }

    private Object endAction = null;
    public void setEndAction(Object obj) {
        endAction = obj;
    }
    public Object getEndAction() {
        return endAction;
    }
    public int getVideoStatus() {
        return this.videoStatus;
    }

    public void play() {
        if(videoSpeed == speed_normal) {
            showTrickPlayBarBriefly();
            return;
        }
        if(videoSpeed != speed_paused) {
            play( TiVo.SOUND_SLOWDOWN1);
        }
        setSpeed( speed_normal );
        showTrickPlayBarBriefly();
    }

    public void pause() {
        if(videoSpeed == speed_paused)
            setSpeed(speed_normal);
        else
            setSpeed(speed_paused);
        showTrickPlayBarBriefly();
    }

    /**
     * OVERRIDE THIS to make a fancier bar like TiVo.  Default is text-based.
     */
    protected TrickPlayView createTrickPlayBar() {
            trickPlayBar = new TextTrickPlayBar(this, SAFE_TITLE_H, getHeight()-SAFE_TITLE_V-20, 
                    getWidth()-2*SAFE_TITLE_H, 20, true);
        return trickPlayBar;
    }
    
    private void updateTrickPlayBar() {
        
        if(trickPlayBar != null && trickPlayBar.getVisible()) {
            trickPlayBar.update(videoPosition, videoDuration, videoDownloaded, videoStatus, videoSpeed, errorCode, errorMess);
        }

    }

    private long getLong(String value) {
        if(value == null) return -1;
        try {
            return Long.parseLong(value);
        } catch (NumberFormatException e) {
            return -1;
        }
    }
//    private int getInt(String value) {
//        if(value == null) return -1;
//        try {
//            return Integer.parseInt(value);
//        } catch (NumberFormatException e) {
//            return -1;
//        }
//    }
    private double getDouble(String value) {
        if(value == null) return 0;
        try {
            return Double.parseDouble(value);
        } catch (NumberFormatException e) {
            return 0;
        }
    }


    /**
     * NOT RECOMMENDED - opens url multiple times to check for redirections,
     * multi-stream sources, and content type. If you only want it opened once,
     * use {@link #setVideo(String, String)} and pass a type (or null if you
     * want it derived from the url)
     * @param url
     */
    public void setVideo(String url) {
        removeVideo();
        initVideo( url );
    }

    /**
     * Clears the current video and starts a new one with the given URL and Mime
     * Type
     * @param url
     * @param type mime type (should be a video/ mp4, quicktime, or mpeg 2) or
     *        null to have it derived from the URL if possible.
     * @param expectedDuration if known, the duration of the video to expect in
     *        the download.
     */
    public void setVideo(String url, String type, int expectedDuration) {
        removeVideo();
        initVideo( url, type, expectedDuration );
    }


    public void removeVideo() {
        if(videoStream != null)
            videoStream.remove();
    }
    
    protected void finalize()
        throws Throwable
    {
        // leaving a video running maxes out the java vm for some reason...crazy stuff.
        // or maybe that was a ticker issue (more likely)...leaving this just in case.
        try {
            removeVideo();
        } catch(Throwable e) {
        }
        super.finalize();
    }
    
    /**
     * @deprecated
     */
    private long rangeEnd;
    /**
     * @deprecated not currently supported, may never be.
     * @param sourceSize
     */
    public void setRangeEnd(long sourceSize) {
        this.rangeEnd = sourceSize;
    }

}
