package com.blackledge.david.html.hme;

import java.awt.Color;
import java.awt.Rectangle;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.CookieHandler;
import java.net.CookieManager;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.text.DateFormat;
import java.text.MessageFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Pattern;

import org.jsoup.UnsupportedMimeTypeException;
import org.jsoup.Connection.Response;

import com.blackledge.david.html.HTMLStyleChunk;
import com.blackledge.david.html.ThreadLocalCookieStore;

import com.blackledge.david.tivo.TiVoModelInfo;
import com.blackledge.david.tivo.TiVoRemoteInfo;
import com.blackledge.david.tivo.V49BApplication;
import com.blackledge.david.tivo.RemotePicker;

import com.blackledge.david.tivo.widgets.typo.TyPo;
import com.blackledge.david.tivo.widgets.typo.TyPoScreen;
import com.blackledge.david.tivo.widgets.typo.WordList;
import com.blackledge.david.tivo.widgets.typo.TyPo.Keyboard;

import com.tivo.core.ds.TeDict;
import com.tivo.core.ds.TeIterator;
import com.tivo.hme.bananas.BScreen;
import com.tivo.hme.bananas.BView;
import com.tivo.hme.interfaces.IContext;
import com.tivo.hme.sdk.HmeEvent;
import com.tivo.hme.sdk.HmeEvent.DeviceInfo;
import com.tivo.hme.sdk.HmeEvent.FontInfo;
import com.tivo.hme.sdk.HmeEvent.Key;
import com.tivo.hme.sdk.IHmeProtocol;
import com.tivo.hme.sdk.Resource;
import com.tivo.hme.sdk.View;

/**
 * <h1>"Enter Webz" - the first ever Web Browser for the TiVo DVR.</h1> <h2>
 * THUMB tacks page controls</h2>
 * <TABLE border=1>
 * <TR>
 * <TH>Thumbs Up</TH>
 * <TD>for "Last Visited" or "(temp)" entries, saves as a THUMB tack</TD>
 * </TR>
 * <TR>
 * <TH>Thumbs Down OR clear</TH>
 * <TD>Delete THUMB tack</TD>
 * </TR>
 * <TR>
 * <TH>enter OR info</TH>
 * <TD>Edit Title</TD>
 * </TR>
 * <TR>
 * <TH>Select OR right OR FF</TH>
 * <TD>Load Link or App</TD>
 * </TR>
 * <TR>
 * <TH>left or RW</TH>
 * <TD>Back. If this is the starting page, quits the app.</TD>
 * </TR>
 * <TR>
 * <TH>Pause</TH>
 * <TD>Quit App</TD>
 * </TR>
 * </TABLE>
 * <h2>Web page controls</h2>
 * <TABLE border=1>
 * <TR>
 * <TH>Thumbs Up</TH>
 * <TD>THUMB tack page (saves session cookies, too)</TD>
 * </TR>
 * <TR>
 * <TH>Thumbs Down</TH>
 * <TD>remove THUMB tack</TD>
 * </TR>
 * <TR>
 * <TH>Play</TH>
 * <TD>Open THUMBS tacks page</TD>
 * </TR>
 * <TR>
 * <TH>RW</TH>
 * <TD>Back. If this is the starting page, quits the app.</TD>
 * </TR>
 * <TR>
 * <TH>1-9</TH>
 * <TD>Change font size</TD>
 * </TR>
 * <TR>
 * <TH>0</TH>
 * <TD>reset to default font size</TD>
 * </TR>
 * <TR>
 * <TH>ASPECT</TH>
 * <TD>change "brightness"</TD>
 * </TR>
 * <TR>
 * <TH>ENTER</TH>
 * <TD>turn off/on table layout (looks better, but takes time & memory and some
 * things end up off screen)</TD>
 * </TR>
 * <TR>
 * <TH>left/right</TH>
 * <TD>select link or form field</TD>
 * </TR>
 * <TR>
 * <TH>up/down</TH>
 * <TD>select link or form field, scroll up/down at edge</TD>
 * </TR>
 * <TR>
 * <TH>channel up/down</TH>
 * <TD>scroll a page up/down</TD>
 * </TR>
 * <TR>
 * <TH>Pause</TH>
 * <TD>Quit App</TD>
 * </TR>
 * <TR>
 * <TH><a href="#">link</a>: Select OR FF</TH>
 * <TD>Load Link</TD>
 * </TR>
 * <TR>
 * <TH><input type="submit" value="submit button">/img button/<button>html
 * button</button>: Select</TH>
 * <TD>Submit form</TD>
 * </TR>
 * <TR>
 * <TH><select><option>select field</option><option>option 2</option></select>:
 * Select</TH>
 * <TD>Open selections list</TD>
 * </TR>
 * <TR>
 * <TH>(selections list): Select OR right</TH>
 * <TD>select entry</TD>
 * </TR>
 * <TR>
 * <TH>(selections list): up/down ; channel up/down ; ADV</TH>
 * <TD>navigate list (single, page, ends)</TD>
 * </TR>
 * <TR>
 * <TH>(selections list): anything else</TH>
 * <TD>cancel selection</TD>
 * </TR>
 * <TR>
 * <TH><input type="checkbox" checked>/<input type="radio" checked>(check/radio
 * field): Select</TH>
 * <TD>check/uncheck field</TD>
 * </TR>
 * <TR>
 * <TH><input type="text" size=4 value="text">/<textarea rows=2
 * cols=8>textarea</textarea>: Select</TH>
 * <TD>Open keyboard</TD>
 * </TR>
 * <TR>
 * <TH>(text field): 0-9</TH>
 * <TD>type a number</TD>
 * </TR>
 * <TR>
 * <TH>(text field): REC</TH>
 * <TD>type a period (".")</TD>
 * </TR>
 * <TR>
 * <TH>(text field): ADV</TH>
 * <TD>type a dash ("-")</TD>
 * </TR>
 * <TR>
 * <TH>(text field): REPLAY</TH>
 * <TD>type a comma (",")</TD>
 * </TR>
 * <TR>
 * <TH>(text field): FF</TH>
 * <TD>type a space</TD>
 * </TR>
 * <TR>
 * <TH>(text field): RW</TH>
 * <TD>delete last character</TD>
 * </TR>
 * <TR>
 * <TH>(text field): CLEAR</TH>
 * <TD>clear field</TD>
 * </TR>
 * </TABLE>
 * <h2>TiVo App (hme://) URLs</h2> Enter Webz supports custom urls of the form
 * <code>hme://hostname:port/path</code> to launch other TiVo Apps.<BR>
 * <var>hostname</var> can be an ip address or a registered domain name that
 * points to the IP address. It processes the URL like this:
 * <OL>
 * <LI>translate the <var>hostname</var> to an <var>ip-address</var>
 * <LI>try to get the TiVoConnect xml file at
 * <code>http://<var>ip-address</var>/TiVoConnect</code>
 * <LI>Check the TiVoConnect file for an hme App entry whose URL has a path that
 * starts with <var>path</var>, and transition to that App
 * <LI>If no app matches, or if there was no TiVoConnect file, attempt to
 * transition to the app at <code>http://<var>ip-address</var>:port/path</code>
 * </OL>
 * <h2>Media URLs</h2> Links that go directly to something other than a text or
 * web page are treated as media URLs. They are passed to the TiVo in hopes that
 * it can handle them. <h3>Pictures</h3> Supported formats are PNG, GIF
 * (including animated GIF), and JPEG.<BR>
 * Use RW or LEFT to return to the previous page. <h3>Music and Audio Files</h3>
 * Supported format is MP3.<BR>
 * Use RW or LEFT to return to the previous page and end the audio.<BR>
 * Use Pause and Play to stop and restart the audio. <h3>Video (TiVos Series 3
 * and later only)</h3> Supported formats are: MPEG, MPEG1, MPEG2, MPEG4 (h.264,
 * and 512KB or higher).<BR>
 * Use LEFT to return to the previous page and end the video.<BR>
 * Use Pause and Play to stop and restart the video.<BR>
 * Use RW and FF to adjust the Rewind and FastForward speed of the video.<BR>
 * If the video reaches the end of the in-progress download, you'll get a
 * "BUFFER END" message. Wait a moment for more to download, then press play
 * again.
 * 
 * @author David Blackledge
 * 
 */
public class WebBrowserApp extends V49BApplication {

	static {
		// add support for the "hme:" protocol in URLs
		System.setProperty("java.protocol.handler.pkgs", //$NON-NLS-1$
				"com.blackledge.david.html"); //$NON-NLS-1$
		// turn on automatic cookie handling
		// have to use a custom CookieStore that loads/stores cookies per
		// TiVo simultaneous... for now one per Thread should do it, though that could end up with multiple per TiVo in theory
//		CookieHandler.setDefault(new CookieManager());
		CookieHandler.setDefault(new CookieManager(new ThreadLocalCookieStore(), null)); // COOKIES
	}

	/**
	 * just expose the AppFactory where the default server expects to find it.
	 */
	public static class WebBrowserAppFactory extends com.blackledge.david.html.hme.WebBrowserAppFactory {
	}

	public WebBrowserApp() {
		super();
		bookmarks = new Bookmarks(this);
		
		addVideoSourceHandler(new EmbedlyHandler(this));
		addVideoSourceHandler(new YouTubeLauncher(this));
		addVideoSourceHandler(new PBSVideoHandler(this));
		addVideoSourceHandler(new VimeoHandler(this));
		//TODO add a VineHandler.getPoster if poster contains("vine.co") or at least a vine icon
		/*TODO vine handling problem...apparently they only allow https??
2014-07-26@11:24:55 DEBUG:show content video/mp4
2014-07-26@11:24:55 DEBUG:(disabled getCookieTeDict)
2014-07-26@11:24:55 DEBUG:app with tivo headers:746000190AA690F:20.4.1-01-2-746
2014-07-26@11:24:56 DEBUG:matched /videoplayer

746000190AA690F 2014-07-26@11:24:56     /webz/  handleMediaContentFailed(	https://v.cdn.vine.co/r/videos/EB818299-A47D-4649-B717-2EC65AA7EF73-4926-000003AB6746D735_1.0.6.mp4?versionId=hrR5cpJHzeVhNBCp9MRsmIFn.rokPCvs  https://vine.co/v/bXZre5gtYgT/embed/postcard    video/mp4       https://v.cdn.vine.co/r/videos/EB818299-A47D-4649-B717-2EC65AA7EF73-4926-000003AB6746D735_1.0.6.mp4?versionId=hrR5cpJHzeVhNBCp9MRsmIFn.rokPCvs  )

2014-07-26@11:24:56 DEBUG:RSRC error:com.tivo.core.ds.MapThreadWrapper@1066240{error.code=6, error.text=Http error: Http connection error:}
2014-07-26@11:24:56 DEBUG:TRYING HTTP: http://vine.co/static/images/embed/vine_logo_white.png
2014-07-26@11:24:56 DEBUG:REDIRECT 1 URL http://vine.co/static/images/embed/vine_logo_white.png-->https://vine.co/static/images/embed/vine_logo_white.png
2014-07-26@11:24:56 DEBUG:(disabled getCookieTeDict)
2014-07-26@11:24:56 DEBUG:RSRC connecting:com.tivo.core.ds.MapThreadWrapper@0{}
2014-07-26@11:24:56 LOG1-DEBUG: Forward Event 1.KEY(release,select,16778246)
2014-07-26@11:24:56 DEBUG:RSRC error:com.tivo.core.ds.MapThreadWrapper@203425092{error.code=6, error.text=Http error: Http connection error:}
		 */
	}

	/**
	 * params TeDict key used in transitionBack call when browser closes. Value
	 * is the String URL of the page displayed at that time.
	 */
	public static final String WEBPAGE_URL = "WEBPAGE_URL"; //$NON-NLS-1$
	/**
	 * params TeDict key used in transitionBack call when browser closes. Value
	 * is the String URL of the icon for the page displayed at that time.
	 */
	public static final String WEBPAGE_TITLE = "WEBPAGE_TITLE"; //$NON-NLS-1$
	public static final String WEBPAGE_ICON = "WEBPAGE_ICON"; //$NON-NLS-1$
	// attributes: {
	// Cookie=id=5d7aa013befaf038e20e7b6873aca31cce0de228,
	// Host=192.168.0.20:7288,
	// User-Agent=TvHttpClient,
	// Connection=close,
	// tsn=65...C5
	// }
	// LOG: event 1.DEVICE_INFO(com.tivo.core.ds.MapThreadWrapper@184554050{
	// com.tivo.examine.idType.stationId=tivo,
	// platform=Gen06,
	// host=Bedroom,
	// brand=TiVo,
	// com.tivo.examine.showing=true,
	// com.tivo.examine.idType.contentId=tivo,
	// version=11.0k-01-2-652
	// })
	// LOG: event
	// 1.RESOLUTION_INFO(640x480-PAR=1/1,avail=[704x480-PAR=40/33,640x480-PAR=1/1,1280x720-PAR=1/1])
	// FIXME new bananas: set maxStackSize for auto-remove of old non-first
	// screens, calls "remove()" (vs. handleExit) (sets numScreensRemoved)
	static final String BROWSER_NAME = Messages.getString("WebBrowserApp.BROWSER_NAME"); //$NON-NLS-1$
	static final String BROWSER_VERSION = Messages.getString("WebBrowserApp.BROWSER_VERSION"); //$NON-NLS-1$
	static final String NOTICE = MessageFormat.format(Messages.getString("WebBrowserApp.NOTICE"),BROWSER_NAME) ; //$NON-NLS-1$

	/** the title presented to the TiVo */
	public static final String TITLE = BROWSER_NAME;
	/** the URI path used by the TiVo to access this application */
	public static final String URI = "webz"; //$NON-NLS-1$

	private static final String LAST_URL_KEY = "LAST_URL"; //$NON-NLS-1$
	private static final String LAST_TITLE_KEY = "LAST_TITLE"; //$NON-NLS-1$

	private static final byte[] MEMENTO_BOOKMARKS = "BOOKMARKS".getBytes(); //$NON-NLS-1$
	private static final byte[] MEMENTO_QUIT_ON_RETURN = "QUIT_ON_RETURN".getBytes(); //$NON-NLS-1$

	/** URL string arg when browser is launched */
	String startURL;
	/** whether bookmarks are allowed */
	private boolean disableBookmarks = false;
	private Bookmarks bookmarks;
	private String latestFolder = null;
	
	/** current scale to use when rendering fonts */
	private float fontScale = 1.0f;
	/**
	 * Whether to apply Table Layout code (otherwise, table cells are treated as
	 * individual lines)
	 */
	private boolean layoutTables = true;

	private WebBrowserTheme theme;

	private BView pleaseWait;
	private TyPoScreen typoScreen;
	private BView typoTitle;
	// private TyPo typo;

	private static DateFormat logdateformat = new SimpleDateFormat(
//			"yyyy-MM-dd'T'HH:mm:ss.SSS"
			"yyyy-MM-dd@HH:mm:ss"
			);
	public static void log(String ID, String where, String what, String[] details) {
		char sep = '\t';
		String time = logdateformat.format(new Date());
		StringBuffer output = new StringBuffer();
		output.append(ID);
		output.append(sep);
		output.append(time);
		output.append(sep);
		output.append(where);
		output.append(sep);
		output.append(what);
		if(details != null) {
			output.append('(');
			for(String detail : details) {
				output.append(sep);
				output.append(detail);
			}
			output.append(sep);
			output.append(')');
		}
		
		System.out.println(output);
	}
	
	public void log(String what, String[] details) {
		log(this.tivoID, this.getFactory().getAppName(), what, details);
	}
	
	private Date appStart = null;
	public void logAppStart(String what) {
		appStart = new Date();
		String stats = null;
		if(deviceInfo != null) stats = deviceInfo.toString();
		
		log("start:"+what, new String[] {stats} );
	}
	
	private String getAppEndDuration() {
		Date appEnd = new Date();
		long appTime = 0;
		if (appStart == null) {
			return "?";
		}
		appTime = appEnd.getTime() - appStart.getTime();
		String mins = String.valueOf(appTime / 1000.0 / 60.0);
		int dot = mins.indexOf('.');
		int dec = 3; // decimal + places
		if ((dot > -1) && ((dot + dec) < mins.length())) {
			mins = mins.substring(0, dot + dec);
		}
		String time = mins + " mins";
		return time;
	}
	
	public void logAppEnd(String what) {
		String time = getAppEndDuration();
		
		log("end:"+what, new String[] {time} );
	}

	public void logAppCrash(String error, String page, String state) {
		String time = getAppEndDuration();
		String options = "";
		log("end:CRASH", new String[] {time, error, page, state, options} );
	}
	
	public void logAppError(int code, String error, Integer resourceId) {
		log("appError", new String[] {String.valueOf(code), error, String.valueOf(resourceId)} );
	}
	
	public void logBookmark(String what, String url, String icon, String folder, String title) {
		folder = Bookmarks.folderToReadablePath(folder);
		log(what, new String[] {url, icon, folder, title});
	}
	
	@Override
	public boolean handleApplicationError(int errorCode, String errorText,
			Integer resourceId) {
		logAppError(errorCode, errorText, resourceId);
		return super.handleApplicationError(errorCode, errorText, resourceId);
	}
	
	public static void debugOut(Object output) {
		if(getDebugLevel() > 0)
			System.out.println(logdateformat.format(new Date())+" DEBUG:"+output);
	}
	
	@Override
	public void debug(String message) {
		WebBrowserApp.debugOut(message);
	}
	
	private static Integer debuglevel;
	public static int getDebugLevel() {
		if(debuglevel == null) {
			debuglevel = Integer.getInteger("com.tivo.hme.sdk.debug.level", 0);
		}
		return debuglevel;
	}
	
	private WebBrowserOptions options = new WebBrowserOptions(this);

	/**
	 * whether or not we want to try and lay out tables
	 * 
	 * @return
	 */
	boolean isLayingOutTables() {
		return layoutTables;
	}

	/**
	 * triggers {@link #saveOptions()}
	 */
	void setLayingOutTables(boolean b) {
		this.layoutTables = b;
	}

	/**
	 * triggers {@link #saveOptions()}
	 */
	void setAppearingMobile(boolean b) {
		options.setAppearingMobile(b);
	}
	
	boolean isAppearingMobile() {
		return options.isAppearingMobile();
	}

	/**
	 * triggers {@link #saveOptions()}
	 */
	void setMaximized(boolean b) {
		options.setMaximized(b);
		// adjust the shared displays
		if (options.isMaximized()) {
			if (this.pleaseWait != null && this.pleaseWait.getChildCount() == 1) {
				View child = this.pleaseWait.getChild(0);
				child.setLocation(child.getX(), 0);
			}
		} else {
			if (this.pleaseWait != null && this.pleaseWait.getChildCount() == 1) {
				View child = this.pleaseWait.getChild(0);
				child.setLocation(child.getX(), getSafeTitleVertical());
			}
		}
	}
	
	boolean isMaximized() {
		return options.isMaximized();
	}

	URLConnectionHandler connect = new URLConnectionHandler(this);
	
	/** get languages for use in Accept-Language header*/
	String getConnectionLanguages() {
		// drive language from the TiVo's settings!
		String language = getDeviceLanguage(); //"en-us"; //"en_us"; "en"; //$NON-NLS-1$
		// try to change format ("enUS") to be similar to useragent style
		if(language.length() > 2) {
			language = language.substring(0, 2) + "-" + language.substring(2); //$NON-NLS-1$
			// also accept all versions of that language if the specific one is not available.
			language += ", "+language.substring(0,2); //$NON-NLS-1$
		}
		// always accept english as an alternative
		language += ", en"; //$NON-NLS-1$
		return language.trim();
	}
	
	String getUserAgent() {
		String tivo = "TiVo"; //$NON-NLS-1$
		if (tivoVersion != null) {
			tivo += "/" + tivoVersion; //$NON-NLS-1$
		}
		//googlebot always includes something like this, so we will, too.
		String url = "+http://EnterWebz.tv/"; //$NON-NLS-1$
		String browser = BROWSER_NAME + "/" + BROWSER_VERSION; //$NON-NLS-1$
		String SEP = "; "; //$NON-NLS-1$
		String enterwebz = browser + SEP + tivo + SEP + url;
		
		// TiVo prefers 8 bit images, and has its own resolution
		int bits = 8;
		int width = 640;
		int height = 480;
		if(isResolutionSupported()) {
			width = getCurrentResolution().getWidth();
			height = getCurrentResolution().getHeight();
		}
		// often "U" (high security), I for weak, and N for none.
		// Since we downgrade some security, we'll call it "I" - but I don't know that's right.
		String security = "I";  //$NON-NLS-1$
		
		// drive language (not a standard) from the TiVo's settings!
		String language = getDeviceLanguage(); //"en-us"; //"en_us"; "en"; //$NON-NLS-1$
		// try to change format ("enUS") to be similar to useragent style
		if(language.length() > 2) {
			language = language.substring(0, 2) + "-" + language.substring(2); //$NON-NLS-1$
		}
		language = language.toLowerCase();
		
		String userAgent = "Mozilla/5.0 (compatible; " + enterwebz + ")"; //$NON-NLS-1$ //$NON-NLS-2$
		if (options.isAppearingMobile()) {
			MOBILE type = options.getMobileType();
			// samsung/docomo/ipad user agents adapted from googlebot's user-agent strings for mobile sites.
			// https://developers.google.com/webmasters/smartphone-sites/googlebot-mobile
			switch(type) {
			// our versions of what Google does:
			case SAMSUNG:
				userAgent = "SAMSUNG-SGH-E250/1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 UP.Browser/6.2.3.3.c.1.101 (GUI) MMP/2.0 (compatible" + SEP + language + SEP //$NON-NLS-1$
						+ enterwebz + ")"; //$NON-NLS-1$
				break;
			case DOCOMO:
				userAgent = "DoCoMo/2.0 N905i(c100;TB;W24H16) (compatible" + SEP + language + SEP //$NON-NLS-1$
						+ enterwebz + ")"; //$NON-NLS-1$
				break;
			case IPAD:
//				Mozilla/5.0 (iPhone; CPU iPhone OS 5_1_1 like Mac OS X) AppleWebKit/ 534.46 (KHTML, like Gecko) Version/5.1 Mobile/9B206 Safari/7534.48.3
//				Mozilla/5.0 (iPad; CPU OS 5_1_1 like Mac OS X) AppleWebKit/534.46 (KHTML, like Gecko) Version/5.1 Mobile/9B206 Safari/7534.48.3
//				AppleCoreMedia/1.0.0.9B176 (iPhone; U; CPU OS 5_1 like Mac OS X; en_us)
//				AppleCoreMedia/1.0.0.9B176 (iPad; U; CPU OS 5_1 like Mac OS X; en_us)
				userAgent = "Mozilla/5.0 (iPad; CPU OS 6_0 like Mac OS X) AppleWebKit/536.26 (KHTML, like Gecko) Version/6.0 Mobile/10A5376e Safari/8536.25 (compatible" + SEP + language + SEP //$NON-NLS-1$
						+ enterwebz + ")"; //$NON-NLS-1$
				break;
			// more options
			case ANDROID:
				userAgent = "Mozilla/5.0 (Linux; " + security + "; Android 2.1; " + language + "; Nexus One Build/ERD62) AppleWebKit/530.17 (KHTML, like Gecko) Version/4.0 Mobile Safari/530.17 (compatible; " //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
						+ enterwebz + ")"; //$NON-NLS-1$
				break;
			case BB:
				userAgent = "BlackBerry7100i/4.1.0 Profile/MIDP-2.0 Configuration/CLDC-1.1 VendorID/103 (compatible" + SEP + language + SEP //$NON-NLS-1$
						+ enterwebz + ")"; //$NON-NLS-1$
				break;
			case OPERA:
				userAgent = "Opera/9.50 (J2ME/MIDP; Opera Mini/4.0.10031/298; " + security + SEP + language + " ; compatible" + SEP //$NON-NLS-1$ //$NON-NLS-2$
						+ enterwebz + ")"; //$NON-NLS-1$
				break;
			case PALM:
				// based on Palm Centro phone
				// it had 16;320x320 at the end
				userAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows 98; PalmSource/Palm-D062; Blazer/4.5) " + bits + ";" + width + "x" + height + SEP + "(compatible" + SEP + language + SEP //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
						+ enterwebz + ")"; //$NON-NLS-1$
				break;
			case AVANTGO:
			default:
				// my original mobile user agent, works in many sites, stopped working correctly at Google, though.
				userAgent = "Mozilla/5.0 (compatible; AvantGo 3.2; compatible" + SEP + language + SEP //$NON-NLS-1$
						+ enterwebz + ") Mobile"; //$NON-NLS-1$
			}
		}
		return userAgent;
	}


	@Override
	protected void initBeforeResolutionSet(IContext context) {

		options.loadOptions();
		restoreSavedFontScale();

		theme = new WebBrowserTheme(this, this.themeURL);

		flush();
		// showFirstPage();

		if (isSDK141()) {
			// TODO probably too low, but might help the memory issues.
			setMaxStackDepth(10);
		}

		// WordList currently requires you call load before you can call
		// addWord.
		WordList wordList = WordList.getInstance();
		wordList.addWord("com/"); //$NON-NLS-1$
		wordList.addWord("org/"); //$NON-NLS-1$
		wordList.addWord("net/"); //$NON-NLS-1$
		wordList.addWord("google.com/"); //$NON-NLS-1$
		wordList.addWord("yahoo.com/"); //$NON-NLS-1$
		wordList.addWord("aol.com"); //$NON-NLS-1$
		wordList.addWord("gmail.com"); //$NON-NLS-1$
		wordList.addWord("html"); //$NON-NLS-1$
		wordList.addWord("http://"); //$NON-NLS-1$
		wordList.addWord("https://"); //$NON-NLS-1$
		wordList.addWord("www."); //$NON-NLS-1$
		// add bookmarks hosts, too.
		java.util.LinkedHashMap<String, URL[]> bookmarks = this.getBookmarks().getBookmarks();
		if (bookmarks != null)
			for (URL[] url : bookmarks.values()) {
				wordList.addWord(url[0].getHost());
			}

//		//COOKIES
//		// that getBookmarks call also loaded cookies from the bookmarks...let's double-check
		this.getBookmarks().initBookmarks();
		
	}
	
	@Override
	protected void destroyCleanup() {
		if(!this.cleanExit) {
			String page = null;
			if (getCurrentScreen() != null) {
				if (getCurrentScreen() instanceof WebScreen) {
					page = ((WebScreen)getCurrentScreen()).getURL().toString();
				} else if (getCurrentScreen() instanceof BookmarkScreen) {
					page = "bookmarks:"+((BookmarkScreen)getCurrentScreen()).folder;
				} else {
					if(getCurrentScreen().getClass() != null) {
						page = getCurrentScreen().getClass().toString();
					}
				}
			}
			//FIXME finish this
			String state = null;
			logAppCrash("dirtyExit", page, state);
		}
		
		// make sure all bookmarks have their latest cookies
		getBookmarks().destroyBookmarks();
	}

	protected void showFirstPage() {
		debugOut("firstPage - startURL: " + startURL); //$NON-NLS-1$

		logAppStart(startURL==null?null:startURL.replaceAll(Pattern.quote(Bookmarks.BOOKMARK_FOLDER_SEPARATOR), "/"));
		
		Rectangle rootBounds = getRoot().getBounds();
		if (rootBounds.getHeight() > 480) {
			if (getTheme().getHDSkin() != null) {
				setSkin(getTheme().getHDSkin());
			}
		} else {
			if (getTheme().getSDSkin() != null) {
				setSkin(getTheme().getSDSkin());
			}
		}
		
		boolean showBookmarks = false;
		String folder = null;
		if (startURL != null) {
			showPleaseWait();
			try {
				URL url = new URL(startURL);
				if (url.getProtocol().toLowerCase().startsWith("hme")) { //$NON-NLS-1$
					debugOut("LOAD APP on init " + url); //$NON-NLS-1$
					this.loadApp(url);
				} else if (url.getProtocol().toLowerCase().startsWith("file")) { //$NON-NLS-1$
					debugOut("LOAD FOLDER on init " + url); //$NON-NLS-1$
					// allow local launch of URL arg using "/" notation,
					// although TiVoConnect will pass "\r" notation here.
					showBookmarks = true;
					folder = Bookmarks.readablePathToFolder(url.toString());
					
					// save future bookmarks in the same folder as this last-used link.
					// (not really relevant since the bookmark screen will handle this, too)
					setLatestFolder(folder);
				} else {
					debugOut("LOAD url on init " + url); //$NON-NLS-1$
					WebScreen webScreen = WebScreen.newWebScreen(this);
					boolean pageSuccess = webScreen.prepare(url);
					if (!pageSuccess) {
						hidePleaseWait();
						webScreen.remove();
						showBookmarks = true;
					} else {
						// save future bookmarks in the same folder as this last-used link.
						setLatestFolder("Apps"+Bookmarks.BOOKMARK_FOLDER_SEPARATOR);
						
						push(webScreen, TRANSITION_FORWARD, url);
					}
				}
			} catch (MalformedURLException ex) {
				showBookmarks = true;
			}
		} else {
			showBookmarks = true;
		}
		
		// Start media AFTER we begin - startup URL may be an App passthrough or
		// other media content.
		if (!this.isStreamActive()) {
			playStartupStreamPIP(this.startMedia);
		}

		if(showBookmarks) {
			if(folder != null) {
				this.showBookmarks(true, folder);
			} else {
				showBookmarks(true);
			}
		}

	}

	public void setStartupStreamCustom(String url) {
		options.setShowMedia(url);
	}
	public void clearStartupStream() {
		setStartupStreamCustom(null);
	}
	public void setStartupStreamLiveTV() {
		setStartupStreamCustom(STREAM_LIVETV);
	}
	public String getStartupStreamCustomURL() {
		if(isStartupStreamLiveTV()) {
			return null;
		} else {
			return options.getMediaURL();
		}
	}
	public boolean isStartupStreamLiveTV() {
		return options.isShowingLiveTV();
//		return options.getMediaURL() != null && options.getMediaURL().equals(STREAM_LIVETV);
	}
	

	/** Is there any active stream type? */
	public boolean isStreamActive() {
		return isStreamTypeVideo() || isStreamTypeAudio();
	}
	/** always returns true if stream is audio */
	public boolean isStreamDisplayPIP() {
		return isStreamTypeAudio()
				|| (isStreamTypeVideo() && this.videoHandler.isPip());
	}
	/** always returns false if stream is audio */
	public boolean isStreamDisplayFS() {
		return isStreamTypeVideo() && !this.videoHandler.isPip();
	}
//	public boolean isStreamDisplayBackgrounded() {
//		//FIXME implement
////		isStreamActive() && 
//		return false;
//	}
	/** returns false if there is no active stream */
	public boolean isStreamTypeVideo() {
		return (this.videoHandler != null && this.videoHandler.isPlaying());
	}
	/** returns false if there is no active stream */
	public boolean isStreamTypeAudio() {
		return (this.audioHandler != null && this.audioHandler.isPlaying());
	}
	private String lastMediaURL;
	/** returns null if stream source is live tv */
	public String getStreamSourceCustomURL() {
		if(!isStreamSourceLiveTV()) {
			if (isStreamActive()) {
				return this.lastMediaURL;
			}
			return null;
		} else {
			return null;
		}
	}
	/** returns false if there is no active stream */
	public boolean isStreamSourceLiveTV() {
		return isStreamTypeVideo() && this.videoHandler.isShowingLiveTV();
	}

	/** may be called only when there is a POSSIBLE change, and might not get called for ALL changes */
	private void notifyWebScreenStreamChanged() {
		BScreen screen = getCurrentScreen();
		if(screen != null && screen instanceof WebScreen) {
			((WebScreen)screen).notifyStreamChanged();
		}
	}
	
	public boolean playStartupStreamPIP(String startupOverrideURL) {
		if (startupOverrideURL != null) {
			if (startupOverrideURL.equals(STREAM_LIVETV)) {
				return playStreamLiveTV(true);
			} else {
				return playStream(startupOverrideURL, null, true);
			}
		} else {
			if (isStartupStreamLiveTV()) {
				return playStreamLiveTV(true);
			} else if(getStartupStreamCustomURL() != null) {
				return playStream(getStartupStreamCustomURL(), null, true);
			}
		}
		return false;
	}
	public boolean playStreamVideo(URL url, String contentType, boolean PIP) {
		return playStreamVideo(url, contentType, PIP, null, null, null, -1);
	}
	public boolean playStreamAudio(URL url, URL referer, String contentType) {
		if (url != null) {
			this.lastMediaURL = url.toString();
		} else {
			this.lastMediaURL = null;
		}
		if (this.videoHandler != null) {
			this.videoHandler.close();
		}
		if (this.audioHandler == null) {
			Rectangle titleRegion = getWebTitleArea();
			int width = (int) (titleRegion.getWidth() / 3);
			width = Math.max(width, 250);
		//			this.audioHandler = new AudioHandlerView(this,
		//					(int) (titleRegion.getX() + titleRegion.getWidth() - width),
		//					(int) (titleRegion.getY() + titleRegion.getHeight()), // below title
		//					width,
		//					(int) titleRegion.getHeight(), true);
			this.audioHandler = new AudioHandlerView(this,
					(int) (titleRegion.getX() + titleRegion.getWidth() - width),
					(int) (titleRegion.getY()),
					width - 20, // space for thumztak
					(int) titleRegion.getHeight(), true);
		}
		this.audioHandler.startAudio(url, referer, contentType);

		notifyWebScreenStreamChanged();
		return true;
	}
	public boolean playStreamLiveTV(boolean PIP) {
		this.lastMediaURL = null;
		if(this.audioHandler != null) {
			this.audioHandler.close();
		}
		if(getCurrentScreen() != null) {
			if(getCurrentScreen() instanceof VideoBackgroundScreen) {
				((VideoBackgroundScreen)getCurrentScreen()).disposeBackground();
			}
		}
		if (this.videoHandler == null) {
			this.videoHandler = new VideoHandlerView(this, PIP, true);
		}
		// hide hints, etc. if we're full screen
		hints.showDecorations(PIP);
		this.videoHandler.setPip(PIP);
		if (!this.videoHandler.isShowingLiveTV()) {
			this.videoHandler.startLiveTV();
		}
		this.videoHandler.show();
		if(getCurrentScreen() != null) {
			if(getCurrentScreen() instanceof VideoBackgroundScreen) {
				((VideoBackgroundScreen)getCurrentScreen()).showBackground();
			}
		}
		notifyWebScreenStreamChanged();
		return true;
	}
	public boolean playStream(String mediaURL, URL referer, boolean PIP) {
		this.lastMediaURL = null; // will get set if a good start happens
		URL urlBase;
		try {
			urlBase = new URL(mediaURL);
		} catch (MalformedURLException e2) {
			return false;
		}
		for(VideoSourceHandler handler : getVideoSourceHandlers()) {
			if(handler.canHandle(urlBase)) {
				if(!handler.launchVideo(urlBase, referer, PIP)) {
//log("playStreamFAIL", new String[]{handler.getClass().toString(), String.valueOf(urlBase), String.valueOf(referer)});
					// try next handler... and fall through if none of them worked
				} else {
//log("playStreamOK", new String[]{handler.getClass().toString(), String.valueOf(urlBase), String.valueOf(referer)});
					notifyWebScreenStreamChanged();
					return true;
				}
			}
		}
		try {
			// just running this to GET the mimetype exc...if we don't get it,
			// it's not the kind of url we need.
			Response soupResp = connect.getResponse(urlBase, referer);
		} catch (UnsupportedMimeTypeException mimeEx) {
			URL url;
			String m = mimeEx.getUrl();
			url = URLConnectionHandler.getURL(urlBase, m);
			if(url == null) {
				// this shouldn't happen, the url string came from a
				// full URL, but let's keep our best option in this
				// case.
				url = urlBase;
			}
			String contentType = mimeEx.getMimeType();
			if (contentType != null) {
				// strip off extra info
				int semicolon = contentType.indexOf(";");
				if (semicolon > 0) {
					contentType = contentType.substring(0, semicolon);
				}
				
				if(contentType.toLowerCase().startsWith("video/")) {
					if(!playStreamVideo(url, contentType, PIP)) {
						return false;
					} else {
						notifyWebScreenStreamChanged();
						return true;
					}
				} else if(contentType.toLowerCase().startsWith("audio/")) {
					if(!playStreamAudio(url, referer, contentType)) {
						return false;
					} else {
						notifyWebScreenStreamChanged();
						return true;
					}
				}
			}
		} catch (IOException e1) {
			return false;
		}
		return false;
	}
	public void closeStream() {
		this.lastMediaURL = null;
		if (this.videoHandler != null) {
			if(getCurrentScreen() != null) {
				if(getCurrentScreen() instanceof VideoBackgroundScreen) {
					((VideoBackgroundScreen)getCurrentScreen()).disposeBackground();
				}
			}
			this.videoHandler.close();
			if(getCurrentScreen() != null) {
				if(getCurrentScreen() instanceof VideoBackgroundScreen) {
					((VideoBackgroundScreen)getCurrentScreen()).showBackground();
				}
			}
		}
		notifyWebScreenStreamChanged();
	}
	public void backgroundStream() {
		if(this.videoHandler != null && this.videoHandler.isPlaying()) {
			this.videoHandler.hide();
		}
	}
	public void foregroundStream() {
		if(this.videoHandler != null && this.videoHandler.isPlaying()) {
			this.videoHandler.show();
		}
	}

	/**
	 * Check this variable during handleExit to find out of the exit is
	 * happening due to a "pop" (leaving this Screen permanently) instead of due
	 * to a "push" (going to a new Screen, will return to this one eventually).
	 */
	public boolean isPopping = false;

	@Override
	public void pop(Object arg) {
		isPopping = true;
		BScreen popped = getCurrentScreen();
		super.pop(arg);
		if (popped != this.typoScreen) {
			// do what removeOldScreens does
			popped.setVisible(false);
			popped.remove();
		}
		isPopping = false;
	}

	/* BEGIN END NEXT LINE HME 1.4.1e only */
	// @Override
	public void replaceCurrentScreen(BScreen newScreen, int transition,
			Object arg) {
		BScreen popped = getCurrentScreen();
		// super.replaceCurrentScreen(newScreen, transition, arg);
		super.pop();
		super.push(newScreen, transition, arg);

		// FIXME removed this for now... causing problems...why???
		// // do what removeOldScreens does
		// popped.setVisible(false);
		// popped.remove();
	}

	@Override
	protected void dispatchKeyEvent(Key ir) {
		// Allow override destination
		// But not to include CALLBACK keys
		if (ir.getCode() == WebScreen.REFRESH_CALLBACK_KEY_CODE
				|| ir.getCode() == WebScreen.SCREEN_TRANSITION_CALLBACK_KEY_CODE) {
			super.dispatchKeyEvent(ir);
		} else {
			if (this.videoHandler != null
					&& this.videoHandler.keyDispatchOverride(ir)) {
				// dispatched, that is an override, so don't do super impl
			} else if (this.audioHandler != null
					&& this.audioHandler.keyDispatchOverride(ir)) {
				// dispatched, that is an override, so don't do super impl
			} else {
				super.dispatchKeyEvent(ir);
			}
		}
	}

	@Override
	public boolean handleKeyPress(int code, long rawcode) {
		if (!super.handleKeyPress(code, rawcode)) {
			switch (code) {
			case KEY_CLEAR:
				logAppEnd("clear");
				closeBrowser();
				return true;
			case KEY_PLAY:
				if (!isBookmarksDisabled()
						&& getCurrentScreen() instanceof WebScreen) {
					showBookmarks();
					return true;
				}
				break;
			case KEY_PAUSE:
				if(isStreamDisplayPIP()) {
					pausePIP();
					return true;
//				} else if(isPlayingAudio()) { // handled in audioHandler.dispatchOverride
//					pauseAudio();
//					return true;
				}
				//TODO not sure we want to do this still
				logAppEnd("pause");
				closeBrowser(); return true;
//				return false;
			case KEY_SLOW:
				if(isStreamDisplayPIP()) {
					closeStream();
					return true;
//				} else if (isPlayingAudio()) { // handled in audioHandler.dispatchOverride
//					closeAudio();
//					return true;
				} else {
					playStreamLiveTV(true);
					return true;
				}
			case KEY_OPT_PIP: //Zoom/Aspect/Window/PIP
				if(isStreamDisplayPIP()) {
					zoomPIP();
					return true;
				}
				return false;
			}
			return false;
		}
		return true;
	}

	private boolean cleanExit = false;
	public void closeBrowser() {
		this.cleanExit = true;
		play(SOUND_SLOWDOWN1);
		
		// return something useful about the current browser state
		// mainly for use with Google Auth stuff, but also useful for restarting
		// where we left off.
		transitionBack(getReturnParams());
		// setActive(false);
	}

	private TeDict getReturnParams() {
		TeDict result = new TeDict();
		// use page they were on, not last visited unless we're not "on" a page.
		if (!(getCurrentScreen() instanceof WebScreen)) {
			URL url = getLastVisited();
			if (url != null) {
				result.add(WEBPAGE_URL, url.toString());
			} else {
				// ok, not even a lastvisited? nothing is worth returning then.
				return null;
			}
			String title = getLastVisitedTitle();
			if (title != null) {
				result.add(WEBPAGE_TITLE, title);
			}
		} else {
			WebScreen screen = (WebScreen) getCurrentScreen();
			if (screen == null)
				return null;
			URL url = screen.getURL();
			if (url != null) {
				result.add(WEBPAGE_URL, url.toString());
			}
			String title = screen.getTitle();
			if (title != null) {
				result.add(WEBPAGE_TITLE, title);
			}
			URL icon = screen.getIconURL();
			if (icon != null) {
				result.add(WEBPAGE_ICON, icon.toString());
			}
		}
		debugOut("RETURNING: " + result); //$NON-NLS-1$
		return result;
	}

	@Override
	public boolean handleKeyRelease(int code, long rawcode) {
		// Handle App Startup key, if so desired
		if (getCurrentScreen() == null) {
			switch (code) {
			case KEY_PLAY:
				debugOut("started with PLAY"); //$NON-NLS-1$
				break;
			case KEY_SELECT:
				debugOut("started with SELECT"); //$NON-NLS-1$
				break;
			case KEY_RIGHT:
				debugOut("started with RIGHT"); //$NON-NLS-1$
				break;
			}
		}
		return super.handleKeyRelease(code, rawcode);
	}

	private TeDict getHMETeDict(URL link) {
		TeDict params = null;

		String q = link.getQuery();
		if (q != null) {
			if (q.startsWith("?"))// TODO this should be unnecessary...query //$NON-NLS-1$
									// doesn't include the ?
				q = q.substring(1);
			params = new TeDict();
			String[] nvps = q.split("&"); //$NON-NLS-1$
			for (String nvp : nvps) {
				String[] nameVal = nvp.split("="); //$NON-NLS-1$
				if (nameVal.length == 2) {
					try {
						String name = URLDecoder.decode(nameVal[0], "UTF-8"); //$NON-NLS-1$
						String val = URLDecoder.decode(nameVal[1], "UTF-8"); //$NON-NLS-1$
						params.add(name, val);
					} catch (UnsupportedEncodingException e) {
						e.printStackTrace();
					}
				}
			}
		}
		return params;
	}

	/**
	 * Load an hme:// url as an app.
	 * 
	 * @param link
	 */
	void loadApp(URL link) {
		
		String loc = connect.getHmeURL(link);
	
		TeDict params = getHMETeDict(link);
		// if(loc.contains("videoplayer")) {
		// loc += "watch/";
		// }

		play(SOUND_SELECT);
		byte[] memento;
		URL start = null;
		if (startURL != null) {
			try {
				start = new URL(startURL);
			} catch (MalformedURLException e) {
			}
		}
		if (link.equals(start)) {
			// if we're loading an app as our start url, when that app returns,
			// we have to quit... act as a pass-through
			memento = MEMENTO_QUIT_ON_RETURN;
		} else {
			memento = createMemento();
		}
		debugOut("transition to hme app:" + loc + "  " //$NON-NLS-1$ //$NON-NLS-2$
				+ params + " MEMENTO:"+new String(memento)); //$NON-NLS-1$
		
		logAppEnd("startApp:"+ loc);
		this.cleanExit = true;
		this.transitionForward(
				loc, params,
				memento);
	}

	/**
	 * If the link has a query, converts it to a Map of name/value pairs,
	 * otherwise it returns null.
	 */
	public Map getHmeMap(URL link) {
		//TODO this whole thing is redundant.  SDK uses map to set query params on the hme URL.
		TeDict dict = getHMETeDict(link);
		if (dict != null) {
			Map params = new HashMap();
			TeIterator names = dict.getNames();
			while (names.hasNext()) {
				String name = (String) names.next();
				Object value = dict.getValue(name, 0);
				params.put(name, value);
			}
			return params;
		}
		return null;
//		Map params = null;
//		String q = link.getQuery();
//		if (q != null) {
//			if (q.startsWith("?"))// TODO this should be unnecessary...query //$NON-NLS-1$
//									// doesn't include the ?
//				q = q.substring(1);
//			params = new HashMap();
//			String[] nvps = q.split("&"); //$NON-NLS-1$
//			for (String nvp : nvps) {
//				String[] nameVal = nvp.split("="); //$NON-NLS-1$
//				if (nameVal.length == 2) {
//					try {
//						String name = URLDecoder.decode(nameVal[0], "UTF-8"); //$NON-NLS-1$
//						String val = URLDecoder.decode(nameVal[1], "UTF-8"); //$NON-NLS-1$
//						params.put(name, val);
//					} catch (UnsupportedEncodingException e) {
//						e.printStackTrace();
//					}
//				}
//			}
//		}
//		return params;
	}
	private byte[] createMemento() {
		if(getCurrentScreen() instanceof BookmarkScreen) {
			String folder = ((BookmarkScreen) getCurrentScreen()).folder;
			if (folder != null) {
				return folder.getBytes();
			} else {
				return MEMENTO_BOOKMARKS;
			}
		}
		URL url = null;
		if(getCurrentScreen() instanceof WebScreen) {
			url = ((WebScreen)getCurrentScreen()).getURL();
		}
		if(url == null) {
			url = getLastVisited();
		}
		if (url != null) {
			return url.toString().getBytes();
		}
		return null;
	}

	private void handleMemento(byte[] memento) {
		if (memento != null && memento.length > 0) {
			if (Arrays.equals(memento, MEMENTO_QUIT_ON_RETURN)) {
				logAppEnd("passthrough");
				closeBrowser();
				return;
			} else if (Arrays.equals(memento, MEMENTO_BOOKMARKS)) {
				// this is the default first page
				return;
			}
			String urlString = new String(memento);
			// try {
			// URL url = new URL(urlString);
			startURL = urlString;
			// } catch (MalformedURLException e) {
			// }
			debugOut("MEMENTO:" + startURL); //$NON-NLS-1$
		}
	}

	private void showBookmarks() {
		showBookmarks(false);
	}

	private void showBookmarks(boolean isFirstPage) {
		showBookmarks(isFirstPage, null);
	}
	
	private void showBookmarks(boolean isFirstPage, String folder) {

		if(!isFirstPage) {
			play(SOUND_TIVO);
		}
		
		BookmarkScreen screen = new BookmarkScreen(this);
		screen.isFirstPage = isFirstPage;
		if (isFirstPage) {
			/* BEGIN HME 1.4.1e only */
			if (isResolutionSupported()) {
				screen.setTargetResolution(this.getReceiverResolutionInfo()
						.getPreferredRenderingResolution());
			}
			/* END HME 1.4.1e only */
		}

		this.push(screen, TRANSITION_FADE, folder);
	}

	public boolean isBookmarksDisabled() {
		return disableBookmarks;
	}
	
	public Bookmarks getBookmarks() {
		return bookmarks;
	}
	
	public String getLatestFolder() {
		return latestFolder;
	}
	
	public void setLatestFolder(String folder) {
		latestFolder = folder;
	}
	
	public String getVideoAppURL() {
		return options.getVideoApp();
	}
	public void setVideoAppURL(String url) {
		if(url == null) {
			url = "";
		} else if(url.contains("://")) {
			url = url.substring(url.indexOf("://")+3);
		}
		options.setVideoApp(url);
	}
	public String getImageProxyURL() {
		return options.getImageProxy();
	}
	public void setImageProxyURL(String url) {
		if(url == null)
			url = "";
		options.setImageProxy(url);
	}
	
	public void setLastVisited(URL url, String title) {
		if (url == null) {
			return;
		}
		if (title == null) {
			title = url.toString();
		}
		getContext().setPersistentData(LAST_TITLE_KEY, title);
		getContext().setPersistentData(LAST_URL_KEY, url.toString());
	}

	URL getLastVisited() {
		String urlString = getContext().getPersistentData(LAST_URL_KEY);
		if (urlString != null) {
			// change to URL
			try {
				return new URL(urlString);
			} catch (MalformedURLException e) {
				return null;
			}
		}
		return null;
	}

	String getLastVisitedTitle() {
		String titleString = getContext().getPersistentData(LAST_TITLE_KEY);
		return titleString;
	}
	
	private View screenBlanker = null;
	@Override
	public boolean handleIdle(boolean isIdle) {
		// if idle, use default handling (go to live tv) unless:
		// we're showing a web screen AND
		// we disallowed timeouts or we are awaiting the page refresh.
		// What it DOES depends on what is running: videostream, page refresh, or other
		// NOTE: refresh check is a race condition: if our idle happens to hit while we're loading the next refresh.
		if (isIdle && getCurrentScreen() != null
				&& getCurrentScreen() instanceof WebScreen
				&& (!this.allowTimeout || ((WebScreen) getCurrentScreen()).isRefreshScheduled())) {
			acknowledgeIdle(true);
			// if refreshing, just do nothing but let the page continue refreshing.
			if (!((WebScreen) getCurrentScreen()).isRefreshScheduled()) {
				// if we're displaying a PIP video, make it full screen
				if (isStreamTypeVideo()) {
					foregroundStream();
					if (isStreamDisplayPIP()) {
						zoomPIP();
					}
				} else {
					blankScreen();
				}
			}
			return true;
		}
		if(!isIdle) {
			// undo any idle handling user can't do on their own.
			// (in other words, leave video full screen, but fix other stuff)
			unblankScreen();
		}
		return super.handleIdle(isIdle);
	}

	private void blankScreen() {
		if (screenBlanker != null) {
			if (screenBlanker.getResource() != null) {
				screenBlanker.getResource().remove();
			}
			screenBlanker.remove();
		}
		screenBlanker = new View(getAbove(), 0, 0, getAbove().getWidth(), getAbove().getHeight());
		screenBlanker.setResource(Color.BLACK);
		screenBlanker.setTransparency(1.0f);
		screenBlanker.setTransparency(0.1f, getResource("*2000"));
	}

	private void unblankScreen() {
		if(screenBlanker != null) {
			Resource anim = getResource("*500");
			screenBlanker.setTransparency(1.0f, anim);
			screenBlanker.setVisible(false, anim);
		}
	}

	private boolean allowTimeout = true;
	
	public void setAllowIdleTimeout(boolean allow) {
		this.allowTimeout = allow;
	}


	private Map<String, Object> resourceDetail = Collections
			.synchronizedMap(new HashMap<String, Object>());
	private URL themeURL = null;
	private String startMedia;

	/**
	 * Only used with Image resources
	 */
	public Object getResourceCache(String src) {
		synchronized (resourceDetail) {			
			return resourceDetail.get(connect.getFixedImageResourceSrc(src, null));
		}
	}

	/**
	 * Only used with Image resources
	 */
	public void putResourceCache(String src, Object obj) {
		synchronized (resourceDetail) {			
			resourceDetail.put(connect.getFixedImageResourceSrc(src, null), obj);
		}
	}

	@Override
	protected void rootBoundsChangedBeforeFirstPage(Rectangle rootBounds) {
		debugOut("ROOT BOUNDS CHANGED "+getReceiverResolutionInfo());
	}
	
//	@Override
//	public ResolutionInfo getReceiverResolutionInfo() {
//		// this method is used by push/pop to decide whether to set the screen's target res.
//		// we don't get an event if receiver did something on its own sometimes.
//		// so we ALWAYS report different info.
//		ResolutionInfo info = super.getReceiverResolutionInfo();
//		Resolution realRes = info.getRenderingResolution();
//		Resolution fakeRes = new Resolution(realRes.getWidth(), realRes.getHeight(), realRes.getPixelAspectNumerator()+1, realRes.getPixelAspectDenominator()+1);
//		return new ResolutionInfo(fakeRes,info.getAvailableRenderingResolutions());
//	}
	
	public WebBrowserTheme getTheme() {
		return theme;
	}

	private Map deviceInfo;
	/** examples: <pre>
	zoneinfo=America/Kentucky/Monticello,
	com.tivo.examine.idType.stationId=tivo,
	platform=Gen07,
	host=DVR-9A72,
	has-recording-capability=true,
	active-ui-mode=flash,
	has-season-pass-capability=true,
	credential-manager-id-mac=001BD7838CE2,
	vod-session-capable=false,
	version=20.3.7.1a-01-2-746,
	country=US,
	has-recording-storage=true,
	credential-manager-id-ccid=47838CE2,
	brand=TiVo,
	language=enUS,
	com.tivo.examine.showing=true,
	com.tivo.examine.idType.contentId=tivo
	</pre>
	*/
	public String getDeviceInfo(String key, String def) {
		if(deviceInfo != null && deviceInfo.get(key) != null) {
			return (String) deviceInfo.get(key);
		} else {
			return def;
		}
	}
	/**
	 * @return defaults to "America"
	 */
	public String getDeviceZone() {
		return getDeviceInfo("zoneinfo", "America");
	}
	/**
	 * @return defaults to "TiVo"
	 */
	public String getDeviceBrand() {
		return getDeviceInfo("brand", "TiVo");
	}
	/**
	 * @return defaults to "en"
	 */
	public String getDeviceLanguage() {
		return getDeviceInfo("language", "en");
	}
	/**
	 * @return defaults to "US"
	 */
	public String getDeviceCountry() {
		return getDeviceInfo("country", "US");
	}
	
	public boolean handleEvent(HmeEvent event) {

		if (event.getOpCode() == EVT_INIT_INFO) {
			// use our memento we stored when we transitioned to another app
			HmeEvent.InitInfo info = (HmeEvent.InitInfo) event;
			handleMemento(info.getMemento());
			handleParams(info.getParams());
			debugOut("PARAMS:" + info.getParams()); //$NON-NLS-1$
		}
		else if (event.getOpCode() == EVT_DEVICE_INFO) {
			deviceInfo = ((DeviceInfo) event).getMap();
		}
		
		boolean result = super.handleEvent(event);
		// ...

		return result;
	}

	private void handleParams(TeDict params) {
		if(params!= null) {
			// Remote Picker return
			String remote = params.getStringOrDefault(RemotePicker.TEDICT_REMOTE, 0, null);
			if(remote != null) {
				setRemote(remote);
				// next time hints are updated, redraw them all.
				hints.resetHints();
			}
		}
	}


	@Override
	protected void setContext(IContext context, int version) {
		super.setContext(context, version);
debugOut("setContext: "+context.getClass());
		
		// context.getConnectionAttribute(HTTP_HEADER_TIVO_ID);
		// tivoVersion is in DEVICE_INFO event under "version"
		// this.tivoVersion =
		// context.getConnectionAttribute(HTTP_HEADER_TIVO_VERSION);

		// try {
		// debugOut("headers from tivo: "+
		// context.getConnectionAttribute("Host"));
		// debugOut(Jsoup.connect("http://"+
		// context.getConnectionAttribute("Host")).ignoreHttpErrors(true).
		// execute().headers().toString());
		// } catch (IOException e) {
		// // TODO Auto-generated catch block
		// e.printStackTrace();
		// }
		// debugOut(HTTP_HEADER_TIVO_ID+": "+tivoID);
		// debugOut(HTTP_HEADER_TIVO_VERSION+": "+tivoVersion);

		// NOTE: for some reason all url-arg connection attributes have their
		// key's lowercased
		WebBrowserApp app = this;
		String instanceStartURL = context.getConnectionAttribute("url"); //$NON-NLS-1$
		if (instanceStartURL != null) {
			app.startURL = instanceStartURL;
			debugOut("CONNECTION ATTRIBUTE:" + app.startURL); //$NON-NLS-1$
		}
		String instanceStartMedia = context.getConnectionAttribute(WebBrowserOptions.URL_MEDIA);
		if(instanceStartMedia != null) {
			app.startMedia = instanceStartMedia;
		}
		String theme = context
				.getConnectionAttribute(WebBrowserOptions.URL_THEME); //$NON-NLS-1$
		if(theme != null) {
			try {
				app.themeURL  = new URL(theme);
			} catch(Exception e) {
				//FIXME log this error
				debugOut("theme URL failed: "+e);
			}
		}
		String disableBookmarks = context
				.getConnectionAttribute(WebBrowserOptions.URL_APPMODE); //$NON-NLS-1$
		app.disableBookmarks = (disableBookmarks != null);
		// FIXME implement domain limiting code
		// String restrictDomain =
		// context.getConnectionAttribute("domainlimit");
		// ((WebBrowserApp)application).domainLimit = domainLimit;
		String font = context.getConnectionAttribute(WebBrowserOptions.URL_FONTSCALE); //$NON-NLS-1$
		if (font != null) {
			try {
				app.fontScale = Float.parseFloat(font);
			} catch (Exception e) {
				WebBrowserApp.debugOut(e);
				// just don't set it.
			}
		}
		String mobile = context.getConnectionAttribute(WebBrowserOptions.URL_MOBILE); //$NON-NLS-1$
		if (mobile != null) {
			if(mobile.length() == 0 || mobile.equalsIgnoreCase("true") || mobile.equals("1") || mobile.equalsIgnoreCase("yes")) {
				this.setAppearingMobile(true);
			} else {
				this.setAppearingMobile(false);
			}
		}
		String style = context.getConnectionAttribute(WebBrowserOptions.URL_STYLE); //$NON-NLS-1$
		if (style != null) {
			try {
				MEDIA mediaStyle = MEDIA.valueOf(style.toUpperCase());
				this.setMediaStyleActive(mediaStyle);
			} catch (IllegalArgumentException e) {
				debugOut("style argument \""+style+"\" is Illegal.");
			}
		}
		String tables = context.getConnectionAttribute(WebBrowserOptions.URL_TABLES); //$NON-NLS-1$
		if (tables != null) {
			if(tables.length() == 0 || tables.equalsIgnoreCase("true") || tables.equals("1") || tables.equalsIgnoreCase("yes")) {
				this.setLayingOutTables(true);
			} else {
				this.setLayingOutTables(false);
			}
		}

	}

	public float getFontScaleRaw() {
		return fontScale;
	}

	public float getFontScale() {
		return getHDAdjustedFontScale(fontScale);
	}

	private float getHDAdjustedFontScale(float originalFontScale) {
		float ratio = ((float) getHeight()) / 480f;
		// make the used increase (amount over 1.0) a fraction of the ratio's
		// increase
		float increaseRate = .5f;
		float hdIncrease = 1.0f + (increaseRate * (ratio - 1.0f));
		// debugOut("hdincrease: "+hdIncrease +" ... "+getHeight()+" v 480");
		if (hdIncrease <= 1.0f) {
			return originalFontScale;
		} else {
			return originalFontScale * hdIncrease;
		}
	}

	public void setFontScale(float fontScale) {
		this.fontScale = fontScale;
	}
	
	/**
	 * revert to font scale last saved with {@link #setFontKey(int)}
	 */
	public void restoreSavedFontScale() {
		float scale = options.getFontScale();
		if(scale > 0f) {
			this.fontScale = scale;
		}
	}
	
	public int getSavedFontKey() {
		float scale = options.getFontScale();
		return getFontScaleKey(scale);
	}

	private Map<String, FontInfo> fontInfos = Collections
			.synchronizedMap(new HashMap<String, HmeEvent.FontInfo>());

	public Map<String, FontInfo> getFontInfos() {
		return fontInfos;
	}
	
	private STATUS pleaseWaitStatus;

	public TeDict getCookieTeDict(URL urlBase, URL referer) {
		if (urlBase == null)
			return null;
		
		//FIXME TeDict turned off for now... it apparently causes reboots when it's wrong
		debugOut("(disabled getCookieTeDict)"); //$NON-NLS-1$
		if(true) return null;
		
		TeDict result = new TeDict();
		// "Invalid parameter list"

		// try to get any set cookies and transfer them via the TeDict
		HttpURLConnection hconn = null;
		try {
			URLConnection connection = urlBase.openConnection();
			if (connection instanceof HttpURLConnection) {
				hconn = (HttpURLConnection) connection;

				// hconn.setRequestMethod("HEAD");//FIXME better, but could
				// prevent proper connection if server coded bad
				hconn.connect();
				hconn.disconnect();
			}
		} catch (Exception e) {
		}

		String headerValue = Bookmarks.getSavedCookie(urlBase);
		if (headerValue != null) {
//			result.add(HTTP_HEADER_COOKIE, headerValue);
//			result.add(HTTP_HEADER_SET_COOKIE, headerValue); //THIS CAUSES A CRASH for vid stream... good sign, sort of!
			// options: 
			// break multi-cookie into multiple Set-Cookie entries
			// set cookie with a TeDict containing cookie name/value pairs
//			result.add(HTTP_HEADER_COOKIE.toLowerCase(), headerValue);
//			result.add(HTTP_HEADER_SET_COOKIE.toLowerCase(), headerValue);
		}
		
//		result.add(HTTP_HEADER_SET_COOKIE, "testSet=CookieSet");
		
		TeDict headers = new TeDict();
		TeDict cookies = getBookmarks().getSavedCookiesAsTeDict(urlBase);
		if(urlBase != null && urlBase.toString().indexOf("EnterWebz")>-1) { //$NON-NLS-1$
			cookies.add("test", "TEST VALUE"); //$NON-NLS-1$ //$NON-NLS-2$
			if(referer == null)
				try {
					referer = new URL("http://referer.fake.net/");
				} catch (MalformedURLException e) { }
		}
		if(cookies != null) {
			result.add(URLConnectionHandler.HTTP_HEADER_SET_COOKIE, cookies); // DIDN'T CRASH (on vid stream)! YAY! (crashed when I passed a string header-content)
			// but it DID crash when I also set "COOKIE" and "cookie" header names with string value.
			// ummm... ok, it crashed once on just an image... but cookies was empty... but that was done for other images on same page, too
			result.add(URLConnectionHandler.HTTP_HEADER_COOKIE, cookies);
			headers.add(URLConnectionHandler.HTTP_HEADER_COOKIE, cookies);
		}
		if(referer != null) {
			headers.add(URLConnectionHandler.HTTP_HEADER_REFERER, referer.toString());
			result.add(URLConnectionHandler.HTTP_HEADER_REFERER, referer.toString());
			result.add(URLConnectionHandler.HTTP_HEADER_REFERER.toLowerCase(), referer.toString());
		}
//		result.add("Request-Headers", headers);
//		result.add("Headers", headers);
//		result.add("HTTP-Headers", headers);
//		result.add("HTTP_Headers", headers);
//		result.add("HTTP-Header", headers);
//		result.add("HTTP_Header", headers);
//		result.add("Request", headers);
//		result.add("HTTP-Request", headers);
//		result.add("request", headers);
//		result.add("http-request", headers);
//		result.add("HTTP_Request", headers);
//		result.add("http_request", headers);
//		result.add("HTTP_REQUEST", headers);
//		result.add("HTTP-REQUEST", headers);

 debugOut(String.valueOf(result));
		return result;
		// TeDict result2 = new TeDict();
		// result2.add("HTTP-Header", result);
		// result2.add("Header", result);
		// result2.add("Headers", result);
		// result2.add("HTTP-Headers", result);
		// result2.add("HTTP-HEADER", result);
		// result2.add("HTTP_HEADER", result);
		// result2.add("HTTP-HEADERS", result);
		// result2.add("HTTP_HEADERS", result);
		// result2.add("HEADER", result);
		// result2.add("HEADERS", result);
		// result2.add("http-header", result);
		// result2.add("http_header", result);
		// result2.add("http-headers", result);
		// result2.add("http_headers", result);
		// result2.add("header", result);
		// result2.add("headers", result);
		// // try space instead of - also
		// result2.add("http", result);
		// result2.add("HTTP", result);
		// System.out.println(result2);
		// return result2;
	}

	/**
	 * Present TyPo keyboard for data entry (puts any PIP in the
	 * background first).
	 * @param typoTitle title to display with the keyboard
	 * 
	 * @return the TyPo reference for further configuration
	 */
	public TyPo showTyPo(String typoTitle) {
		backgroundStream();
		hints.showDecorations(false);
		// set up a global top-level keyboard for use throughout the app.
		if (this.typoScreen == null) {
			TyPo.setUserWordListAllowed(false);
			this.typoScreen = new TyPoScreen(this, this.protocolVersion);
			Rectangle titleRegion = getTitleRegion();
			this.typoTitle = new BView(typoScreen.getAbove(), titleRegion.x, titleRegion.y, titleRegion.width, titleRegion.height);
			// this.typo = this.typoScreen.getTyPo();
			this.setTyPoSettings();
		}
		// try to look consistent with the source screen
		this.typoScreen
				.setResource(getCurrentScreen().getBelow().getResource());
		// set the title.
		if(typoTitle == null) {
			this.typoTitle.clearResource();
		} else {
			//using V49BApplication's createText shorthand
			this.typoTitle.setResource(Color.white + "system-"+(int)(15*getHeightMultiplier())+".font:"+typoTitle,
					RSRC_TEXT_WRAP | RSRC_VALIGN_TOP | RSRC_HALIGN_CENTER);
		}

		push(this.typoScreen, TRANSITION_NONE);
		return this.typoScreen.getTyPo();
	}

	/**
	 * Pops the TyPo screen if it's showing and resets most configuration of
	 * TyPo. (restores any backgrounded PIP first)
	 */
	public void closeTyPo() {
		foregroundStream();
		hints.showDecorations(true);
		if (getCurrentScreen() instanceof TyPoScreen)
			pop();
		// pop(((TyPoScreen)getCurrentScreen()).getTyPo().getValue());
		setTyPoSettings();
	}

	private void setTyPoSettings() {
		this.typoScreen.getTyPo().setKeyboard(Keyboard.DEFAULT);
		this.typoScreen.getTyPo().setActions(null, null);
		this.typoScreen.getTyPo().setActivateOnFocus(true);
		// this.typoScreen.getTyPo().setExitOptions(TyPo.EXIT_CANCEL,
		// TyPo.EXIT_FINISHED, true, false, false, false);
		this.typoScreen.getTyPo().setUseCompletions(true);
		// this.typoScreen.getTyPo().setValue("");
		
		this.typoScreen.getBelow().setResource("0x000033");
	}

	public static enum STATUS {
		CONNECTING, CONNECTING_STREAM, PARSING, PARSING_XML, PARSING_CSS, PARSING_HTML, REDIRECTING, COMPLETE
	};
	public void setLoadingStatus(STATUS status) {
		if(this.pleaseWait != null) {
			synchronized(this.pleaseWait) {
				this.pleaseWaitStatus = status;
				int statusTotal = STATUS.values().length;
				int percentInt = this.pleaseWaitStatus.ordinal()+1;
				float percent = (float)percentInt / (float)statusTotal;
				showProgress(percent);
			}
		}
	}

	private void showProgress(float percent) {
		if(this.pleaseWait.getChildCount() == 0) {
			if(isMaximized()) {
				new BView(this.pleaseWait, getSafeTitleHorizontal(), 0, 
						this.pleaseWait.getWidth()-2*getSafeTitleHorizontal(), 20);
			} else {
				new BView(this.pleaseWait, getSafeTitleHorizontal(), getSafeTitleVertical(), 
						this.pleaseWait.getWidth()-2*getSafeTitleHorizontal(), 20);
			}
		}
		BView prog = (BView) this.pleaseWait.getChild(0);
		prog.setSize((int) ((this.pleaseWait.getWidth()-2*getSafeTitleHorizontal())*percent), prog.getHeight());
		String statusResource = getTheme().getProgress(this.pleaseWaitStatus);
		prog.setResource(statusResource, RSRC_HALIGN_LEFT | RSRC_VALIGN_CENTER | RSRC_IMAGE_BESTFIT);
	}
	
	public void setLoadingStatus(int progress, int maxProgress) {
		if(this.pleaseWait == null) return;
		synchronized(this.pleaseWait) {
			int statusTotal = STATUS.values().length;
			int percentInt = this.pleaseWaitStatus.ordinal()+1;
			float percent = (float)percentInt / (float)statusTotal;
			float partPercent = (float)progress / (float)maxProgress;
			percent += partPercent*(1f/(float)statusTotal); 
			showProgress(percent);
		}
	}
	
	public void showPleaseWait() {
		if (this.pleaseWait == null) {
			// set up a global top-level please-wait for use throughout the app.

			this.pleaseWait = new BView(getAbove(), 0, 0,
					getAbove().getWidth(), getAbove().getHeight(), false);
			this.pleaseWait.setResource(getTheme().getPleaseWait(),
					RSRC_HALIGN_CENTER | RSRC_VALIGN_CENTER);
		}
		if (this.pleaseWait != null) {
			this.pleaseWait
					.setLocation((getNormal().getWidth() - this.pleaseWait
							.getWidth()) / 2,
							(getNormal().getHeight() - this.pleaseWait
									.getHeight()) / 2);
			this.pleaseWait.setVisible(true);
		}
	}

	public void hidePleaseWait() {
		if (this.pleaseWait != null)
			this.pleaseWait.setVisible(false);
	}

	HashMap<String, FontInfo> localFontInfos = new HashMap<String, FontInfo>();
	private AudioHandlerView audioHandler;
	static final float TEXT_SCALE_9 = 2.0f;
	static final float TEXT_SCALE_8 = 1.75f;
	static final float TEXT_SCALE_7 = 1.5f;
	static final float TEXT_SCALE_6 = 1.25f;
	static final float TEXT_SCALE_4 = .9f;
	static final float TEXT_SCALE_3 = .8f;
	static final float TEXT_SCALE_2 = .7f;
	static final float TEXT_SCALE_1 = .6f;
	static final float TEXT_SCALE_5 = 1.0f;

	private static float[] text_scales = {WebBrowserApp.TEXT_SCALE_1, WebBrowserApp.TEXT_SCALE_2, WebBrowserApp.TEXT_SCALE_3, WebBrowserApp.TEXT_SCALE_4, WebBrowserApp.TEXT_SCALE_5, WebBrowserApp.TEXT_SCALE_6, WebBrowserApp.TEXT_SCALE_7, WebBrowserApp.TEXT_SCALE_8, WebBrowserApp.TEXT_SCALE_9};
	
	/**
	 * triggers {@link #saveOptions()}, unlike other variations.
	 */
	public void setFontKey(int key) {
		setFontScale(getFontScale(key));
		options.setFontScale(getFontScaleRaw());
	}
	
	public float getFontScale(int key) {
		if(key <= 0 || key >= text_scales.length+1)
			key = 5;
		return(text_scales[key-1]);
	}
	
	public int getFontScaleKey() {
		float scale = getFontScaleRaw();
		return getFontScaleKey(scale);
	}

	private int getFontScaleKey(float scale) {
		if(scale == WebBrowserApp.TEXT_SCALE_1)
			return 1;
		else if(scale == WebBrowserApp.TEXT_SCALE_2)
			return 2;
		else if(scale == WebBrowserApp.TEXT_SCALE_3)
			return 3;
		else if(scale == WebBrowserApp.TEXT_SCALE_4)
			return 4;
		else if(scale == WebBrowserApp.TEXT_SCALE_5)
			return 5;
		else if(scale == WebBrowserApp.TEXT_SCALE_6)
			return 6;
		else if(scale == WebBrowserApp.TEXT_SCALE_7)
			return 7;
		else if(scale == WebBrowserApp.TEXT_SCALE_8)
			return 8;
		else if(scale == WebBrowserApp.TEXT_SCALE_9)
			return 9;
		else return 5;
	}

	public static enum MEDIA {TV, SCREEN, HANDHELD};
	public static enum MOBILE {AVANTGO, DOCOMO, SAMSUNG, IPAD, ANDROID, BB, OPERA, PALM};

	public boolean isMediaStyleActive(MEDIA type) {
		return options.isMediaStyleActive(type);
	}
	public MEDIA getMediaStyle() {
		return options.getMediaStyle();
	}
	/**
	 * triggers {@link #saveOptions()}
	 */
	public void setMediaStyleActive(MEDIA type) {
		options.setMediaStyleActive(type);
	}
	
	public boolean isMobileTypeActive(MOBILE type) {
		return options.isMobileTypeActive(type);
	}
	public MOBILE getMobileType() {
		return options.getMobileType();
	}
	/**
	 * triggers {@link #saveOptions()}
	 */
	public void setMobileTypeActive(MOBILE type) {
		options.setMobileType(type);
	}

	public void handleMenuAction(String action) {
		if(action.startsWith(WebMenuScreen.MENU_FONT_PREFIX)) {
			int fontnum = Integer.parseInt(action.substring(WebMenuScreen.MENU_FONT_PREFIX.length()));
			this.setFontKey(fontnum);
		} else if(action.equals(WebMenuScreen.MENU_TABLES)) {
			this.setLayingOutTables(!this.isLayingOutTables());
		} else if(action.equals(WebMenuScreen.MENU_MAXIMIZE)) {
			this.setMaximized(!this.isMaximized());
		} else if(action.equals(WebMenuScreen.MENU_LEFT_BACK)) {
			this.setLeftSameAsBack(!this.isLeftSameAsBack());
		} else if(action.equals(WebMenuScreen.MENU_MOBILE)) {
			this.setAppearingMobile(!this.isAppearingMobile());
		} else if(action.startsWith(WebMenuScreen.MENU_STYLE_PREFIX)) {
			String style = action.substring(WebMenuScreen.MENU_STYLE_PREFIX.length());
			try {
				this.setMediaStyleActive(MEDIA.valueOf(style.toUpperCase()));
			} catch(Exception e) {
				this.setMediaStyleActive(MEDIA.TV);
			}
		} else if(action.startsWith(WebMenuScreen.MENU_MODE_PREFIX)) {
			String mode = action.substring(WebMenuScreen.MENU_MODE_PREFIX.length());
			try {
				this.setMobileTypeActive(MOBILE.valueOf(mode.toUpperCase()));
			} catch(Exception e) {
				this.setMobileTypeActive(MOBILE.PALM);
			}
		}
	}

	public boolean isLeftSameAsBack() {
		return options.isLeftSameAsBack();
	}
	
	/**
	 * triggers {@link #saveOptions()}
	 */
	public void setLeftSameAsBack(boolean leftSameAsBack) {
		options.setLeftSameAsBack(leftSameAsBack);
	}

	public boolean isShaded() {
		return options.isShaded();
	}

	/**
	 * triggers {@link #saveOptions()}
	 */
	public void setShaded(boolean shade) {
		options.setShaded(shade);
	}

	/**
	 * get an HME font specification based on an HTMLStyleChunk and the current
	 * theme's font translations
	 * 
	 * @param styleChunk
	 * @param fontSizePercent
	 * @return
	 */
	public String getFontString(HTMLStyleChunk styleChunk, float fontSizePercent) {
		String fontFamily = getValidFontName(styleChunk);

		String style = null;
		if(styleChunk.isBold && styleChunk.isItalic) {
			style = "bolditalic";
		} else if(styleChunk.isBold) {
			style = "bold";
		} else if(styleChunk.isItalic) {
			style = "italic";
		}
		int size = styleChunk.fontSize;
//		System font shows up a little larger than default font.
		if(fontFamily.equals("system") && size > 3) {
			size -= 3;
		}
		if(style != null) {
			return fontFamily+"-"+(int)(size*fontSizePercent)+"-"+style+".font";
		} else {
			return fontFamily+"-"+(int)(size*fontSizePercent)+".font";
		}
	}

	private HashMap<String, Resource> urlFonts = new HashMap<String, Resource>();
	private String getValidFontName(HTMLStyleChunk styleChunk) {
		String fontFamily1 = String.valueOf(styleChunk.font).toLowerCase();
		//TODO handle quotes
//		debugOut("FONT-FAMILY:"+fontFamily1);
		String translated;
		translated = theme.getFontTranslation(fontFamily1);
		if (translated == null) {
			// default translation
			//TODO "arial" is common.
			//TODO "inherit"
			String sans = "default";
			String mono = "system";
			String cursive = "default";
			String fantasy = "system";
			String serif = "default";
			if (fontFamily1 == null)
				translated = serif;
			else if (fontFamily1.equals("sans-serif"))
				translated = sans;
			else if(fontFamily1.equals("monospace"))
				translated = mono;
			else if(fontFamily1.equals("cursive")) 
				translated = cursive;
			else if(fontFamily1.equals("fantasy"))
				translated = fantasy;
			else if(fontFamily1.equals("serif"))
				translated = serif;
			else if(fontFamily1.equals("system"))
				translated = "system";
			else
				translated = serif;
		}
		String fontFamily = translated;
		
		// can have a URL font, but using it as a font string will just result in a streamresource, not a font.
		int slashes = fontFamily.indexOf("://");
		if (slashes > 0) {
			String resourceName = null;
			synchronized (urlFonts) {
				Resource tt = urlFonts.get(fontFamily);
				if(tt == null) {
					if (fontFamily.endsWith(".ttf")) {
						tt = createTrueType(fontFamily);
					} else {
						tt = createTrueType(fontFamily+".ttf");
					}
					// we have to store the actual resource, or GC will tell TiVo to remove it.
					urlFonts.put(fontFamily, tt);
				}
				// we can only access this cached resource by its id
				resourceName = String.valueOf(tt.getID());
			}
			fontFamily = resourceName;
		}
		return fontFamily;
	}

	public void advanceAudio() {
		if(this.audioHandler!=null) {
			this.audioHandler.skip();
		}
	}

	public void pauseAudio() {
		if(this.audioHandler!=null) {
			this.audioHandler.pause();
		}
	}

	public void closeAudio() {
		if(this.audioHandler!=null) {
			this.audioHandler.close();
		}
	}

	private VideoHandlerView videoHandler;

	public void zoomPIP() {
		if (this.videoHandler != null) {
			// hide hints, etc. if we're full screen
			hints.showDecorations(! this.videoHandler.isPip());
			this.videoHandler.setPip(! this.videoHandler.isPip());
		}
	}

	public void pausePIP() {
		if (this.videoHandler != null) {
			this.videoHandler.pause();
		}
	}

	/**
	 * Show a video by launching this HME app specification
	 * @param PIP 
	 * @param originURL 
	 * @return true if launch worked.
	 */
	boolean playStreamVideoApp(String hmeURL, Map hmeMap, boolean PIP, String originURL) {
		this.lastMediaURL = originURL;
		if(this.audioHandler != null) {
			this.audioHandler.close();
		}
		if(this.videoHandler == null) {
			this.videoHandler = new VideoHandlerView(this, PIP, true);
		}
		// hide hints, etc. if we're full screen
		hints.showDecorations(PIP);
		//FIXME don't do PIP if this is SD mode, and prevent going PIP on exit/zoom of FS
		this.videoHandler.setPip(PIP);
		this.videoHandler.startAppVideo(hmeURL, hmeMap, PIP);
		
		return true;
	}

	/**
	 * Show a video by launching the videoplayer with these details.
	 * @param videoURL if https, passes http version of it to videoplayer in "uri" parameter
	 * @param contentType NOT CURRENTLY USED
	 * @param PIP 
	 * @param title defaults to URL filename
	 * @param subtitle defaults to URL host if title is using default
	 * @param description defaults to full URL
	 * @param duration if greater than zero, used in "duration" param to video player
	 * @return true if launch worked.
	 */
	public boolean playStreamVideo(URL videoURL, String contentType, boolean PIP, String title, String subtitle, String description, int duration) {
		if (title == null) {
			title = videoURL.getFile();
			int lastslash = title.lastIndexOf("/"); //$NON-NLS-1$
			if(lastslash >= 0 && lastslash < (title.length()-1)) {
				title = title.substring(lastslash + 1);
			}
			if (subtitle == null) {
				subtitle = videoURL.getHost();
			}
		} else if (subtitle == null) {
			subtitle = ""; //$NON-NLS-1$
		}
		if (description == null) {
			description = "\n"+videoURL.toString(); //$NON-NLS-1$
		}
		String durationString = ""; //$NON-NLS-1$
		if (duration > 0) {
			durationString = "&duration=" + duration; //$NON-NLS-1$
		}
	
		String videoUrl = videoURL.toString();
		try {
			String contentTypeString = ""; //$NON-NLS-1$
			if (contentType != null && contentType.length() > 0) {
				contentTypeString = "&" //$NON-NLS-1$
						+ "mime=" + URLEncoder.encode(contentType, "UTF-8"); //$NON-NLS-1$ //$NON-NLS-2$
			}
			String subtitleString = ""; //$NON-NLS-1$
			if (subtitle.length() > 0) {
				subtitleString = "&" //$NON-NLS-1$
						+ "subtitle=" + URLEncoder.encode(subtitle, "UTF-8"); //$NON-NLS-1$ //$NON-NLS-2$
			}
			
			String videoApp = getVideoAppURL();
			if(videoApp == null || videoApp.trim().length() == 0) {
				videoApp = "204.176.49.116:7288/videoplayer"; //$NON-NLS-1$
				// default video app needs fixed url
				//TODO referer info for video stream would be nice.
				videoUrl = connect.getFixedVideoResourceSrc(videoUrl, null);
			}
			String hmeURI =
					"hme://"+videoApp+"?" //$NON-NLS-1$ //$NON-NLS-2$
					+ "uri="+URLEncoder.encode(videoUrl, "UTF-8") //$NON-NLS-1$ //$NON-NLS-2$
					+ "&" //$NON-NLS-1$
					+ "title="+URLEncoder.encode(title, "UTF-8") //$NON-NLS-1$ //$NON-NLS-2$
					+ subtitleString
					+ contentTypeString
					+ "&" //$NON-NLS-1$
					+ "description="+URLEncoder.encode(description, "UTF-8") //$NON-NLS-1$ //$NON-NLS-2$
					+ durationString
					;
			// prevent url length error due to optional data... leave a little
			// room for the changes in final url
			if(hmeURI.length() > IHmeProtocol.LIMIT_URL_NBYTES-10) {
				// just chop it off.. options were added in priority order
				hmeURI = hmeURI.substring(0, IHmeProtocol.LIMIT_URL_NBYTES-10);
			}
			URL url = new URL(hmeURI);
			//TODO this ALWAYS returns true.
			return this.playStreamVideoApp(connect.getHmeURL(url), getHmeMap(url), PIP, videoUrl);
		} catch (UnsupportedEncodingException e) {
			String[] mediaContentDetails = new String[] {String.valueOf(videoUrl), "will retry with default Video handling", contentType, String.valueOf(videoURL), String.valueOf(e)};
			((WebBrowserApp)getApp()).log("handleMediaContentFailed", mediaContentDetails);
			e.printStackTrace();
		} catch (MalformedURLException e) {
			String[] mediaContentDetails = new String[] {String.valueOf(videoUrl), "will retry with default Video handling", contentType, String.valueOf(videoURL), String.valueOf(e)};
			((WebBrowserApp)getApp()).log("handleMediaContentFailed", mediaContentDetails);
			e.printStackTrace();
		}
		
		return false;
	}

	public Rectangle getWebTitleArea() {
		Rectangle renderArea = getWebRenderArea();
		if (this.isMaximized()) {
			return new Rectangle((int) renderArea.getX(), 0,
					(int) renderArea.getWidth(), this.getSafeActionVertical());
		} else {
			return new Rectangle((int) renderArea.getX(),
					getSafeActionVertical(), (int) renderArea.getWidth(),
					getSafeTitleVertical() - getSafeActionVertical());
		}
	}
	
	public Rectangle getWebStatusArea() {
		Rectangle renderArea = getWebRenderArea();
		if (isMaximized()) {
			return new Rectangle((int) renderArea.getX(), this.getHeight()
					- (getSafeActionVertical()), (int) renderArea.getWidth(),
					getSafeActionVertical());
		} else {
			return new Rectangle((int) renderArea.getX(), this.getHeight()
					- (getSafeTitleVertical()), (int) renderArea.getWidth(),
					getSafeTitleVertical() - getSafeActionVertical());
		}
	}
	
	public Rectangle getWebRenderArea() {
		WebBrowserApp wba = this;
		int renderAreaHInset;
		int scrollbarHInset;
		int scrollbarWidth = getWebScrollbarWidth();
		
		if(wba.isMaximized()) {
			// maximized = horizontal only leaves room for scrollbar, vertical
			// statuses go against edge
			renderAreaHInset = wba.getSafeActionHorizontal()/2;
			scrollbarHInset = Math.max(0,renderAreaHInset + scrollbarWidth);
			return new Rectangle(
					renderAreaHInset, wba.getSafeActionVertical(), 
					this.getWidth() - renderAreaHInset - scrollbarHInset,
					this.getHeight() - wba.getSafeActionVertical() * 2);
		} else {
			renderAreaHInset = wba.getSafeTitleHorizontal();
			scrollbarHInset = Math.max(0,renderAreaHInset + scrollbarWidth);
			return new Rectangle(
					renderAreaHInset, wba.getSafeTitleVertical(), 
					this.getWidth() - renderAreaHInset - scrollbarHInset,
					this.getHeight() - wba.getSafeTitleVertical() * 2);
		}
	}

	public int getWebScrollbarWidth() {
		WebBrowserApp wba = this;
		int min = 20;
		try {
			min = wba.getSkin().get(H_PAGEDOWN).getWidth();
		} catch(Exception e) {}
		int scrollbarWidth = min*2;
		int max = 100;
		try {
			max = wba.getSkin().get("scroll_bar").getWidth();
		} catch(Exception e) {}
		max = Math.min(wba.getSafeActionHorizontal(), max);
		scrollbarWidth = Math.min(max, scrollbarWidth);
		scrollbarWidth = Math.max(min, scrollbarWidth);
		return scrollbarWidth;
	}

	private TiVoRemoteInfo _remote = null;
	public TiVoRemoteInfo getRemote() {
		if (_remote == null) {
			String saved_remote = options.getRemoteID();
			_remote = TiVoRemoteInfo.getRemote(saved_remote);
			if(_remote == null) {
				TiVoModelInfo model = TiVoModelInfo.getInfo(this.getContext().getConnectionAttribute("tsn")); //$NON) //$NON-NLS-1$
				if (model != null) {
					_remote = model.getDefaultRemote();
				}
				if (_remote == null) {
					_remote = TiVoRemoteInfo.getDefaultRemote();
				}
			}
		}
		return _remote;
	}
	
	private void setRemote(String id) {
		TiVoRemoteInfo remote = TiVoRemoteInfo.getRemote(id);
		if(remote == null) {
			play(SOUND_BONK);
		} else {
			_remote = remote;
			options.setRemoteID(remote.getID());
		}
	}

	// bookmarks/quit/size hints
	/**
	 * access the hint decorations controls for the browser
	 */
	Hints hints = new Hints(this);

	private List<VideoSourceHandler> _videoSourceHandlers = new ArrayList<VideoSourceHandler>();
	/** Registered Video Source handlers */
	public List<VideoSourceHandler> getVideoSourceHandlers() {
		return new ArrayList<VideoSourceHandler>(_videoSourceHandlers);
	}
	private void addVideoSourceHandler(VideoSourceHandler handler) {
		_videoSourceHandlers.add(handler);
	}

}
