package com.blackledge.david.tivo.game;

import java.awt.Color;
import java.awt.Rectangle;

import com.blackledge.david.game.Card;
import com.tivo.hme.bananas.BView;
import com.tivo.hme.sdk.Resource;

public class CardView extends BView {

	private BView _numberTL;
	private BView _numberBR;
	private BView _face;
	private Card _currentState;

	public CardView(BView parent, int x, int y, int width,
			boolean visible, Card card) {
		super(parent, x, y, width, getHeight(width), visible);
		Rectangle innerCard = new Rectangle(
				(int) (getWidth() * .03), (int) (getHeight() * .03), 
				(int) (getWidth() * .94), (int) (getHeight() * .94));
		_numberTL = new BView(this, innerCard.x, innerCard.y, innerCard.width, innerCard.height, false);
		_numberBR = new BView(this, innerCard.x, innerCard.y, innerCard.width, innerCard.height, false);
		_face = new BView(this, innerCard.x, innerCard.y, innerCard.width/2, innerCard.height, false);
		setState(card);
	}

	public void setState(Card card) {
		if(card == null) return;
		
		setPainting(false);
		
		boolean flipped = false;
		if (_currentState == null || card.isFaceUp() != _currentState.isFaceUp()) {
			flipped = true;
			_numberTL.setVisible(card.isFaceUp());
			_numberBR.setVisible(card.isFaceUp());
			_face.setVisible(card.isFaceUp());
			if(card.isFaceUp()) {
				setResource(getCardFaceResource(card.getSuit()), RSRC_IMAGE_BESTFIT);
			} else {
				setResource(getCardBackResource(), RSRC_IMAGE_BESTFIT);
			}
		} else {
			if (card.isFaceUp()) {
				if (_currentState == null || card.getSuit() != _currentState.getSuit()) {
					setResource(getCardFaceResource(card.getSuit()), RSRC_IMAGE_BESTFIT);
				}
			}
		}
		if (card.isFaceUp()) {
			if (flipped || _currentState == null
					|| card.getValue() != _currentState.getValue()
					|| card.getSuitColor() != _currentState.getSuitColor()) {
				Color suitColor = Color.black;
				if(card.getSuitColor() == Card.RED) {
					suitColor = Color.red;
				}
				Resource number = createText("default-"+(getWidth()*1/4)+"-bold.font", suitColor, card.getValueString());
				_numberTL.setResource(number, RSRC_VALIGN_TOP|RSRC_HALIGN_LEFT);
				_numberBR.setResource(number, RSRC_VALIGN_BOTTOM|RSRC_HALIGN_RIGHT);
				
				Resource faceResource = null;
				boolean image = false;
				switch(card.getValue()) {
//				case Card.ACE:
//					switch(card.getSuit()) {
//					case Card.CLUB:
//						faceResource = getResource("http://enterwebz.tv/");
//						break;
//					case card.DIAMOND:
//						faceResource = getResource("http://enterwebz.tv/");
//						break;
//					case card.HEART:
//						faceResource = getResource("http://enterwebz.tv/");
//						break;
//					case card.SPADE:
//						faceResource = getResource("http://enterwebz.tv/");
//						break;
//					}
//					break;
				case Card.JACK:
					faceResource = getResource("com/blackledge/david/tivo/game/JackHat.png");
					image = true;
					break;
				case Card.QUEEN:
					faceResource = getResource("com/blackledge/david/tivo/game/QueenHat.png");
					image = true;
					break;
				case Card.KING:
					faceResource = getResource("com/blackledge/david/tivo/game/KingHat.png");
					image = true;
					break;
				default:
					faceResource = createText("default-"+(getWidth()*1/2)+".font", suitColor, card.getValueString());
					break;
				}
//				faceResource = createText("default-"+(getWidth()*2/3)+".font", suitColor, "  "+card.toString());
				
				if(image)
				_face.setResource(faceResource, RSRC_HALIGN_LEFT|RSRC_VALIGN_CENTER|RSRC_IMAGE_VFIT);
				else
				_face.setResource(faceResource, RSRC_HALIGN_CENTER|RSRC_VALIGN_CENTER);
			}
		}
		
		setPainting(true);

		_currentState = new Card(card.getSuit(), card.getValue(), card.isFaceUp());
	}
	
	private Object getCardBackResource() {
//		return Color.ORANGE.darker().darker();
		return getResource("com/blackledge/david/tivo/game/CardBack.png");
	}

	private Object getCardFaceResource(int suit) {
		switch(suit) {
		case Card.CLUB:
			return getResource("com/blackledge/david/tivo/game/ClubCard.png");
		case Card.DIAMOND:
			return getResource("com/blackledge/david/tivo/game/DiamondCard.png");
		case Card.HEART:
			return getResource("com/blackledge/david/tivo/game/HeartCard.png");
		case Card.SPADE:
			return getResource("com/blackledge/david/tivo/game/SpadeCard.png");
		}
		return Color.WHITE.darker();
	}

	public static int getHeight(int width) {
		return (int) (width*(3.5/2.5));
	}

}
