package com.blackledge.david.tivo.game.chainreaction;

import com.blackledge.david.game.MultiplayerGame;
import com.blackledge.david.game.PlayerState;

import com.blackledge.david.game.chainreaction.ChainReactionGame;

import com.blackledge.david.tivo.game.Game;
import com.blackledge.david.tivo.game.GameLobby;
import com.tivo.hme.sdk.HmeEvent;
import com.tivo.hme.sdk.Resource;

public class PigeonHole extends Game {

	public static class PigeonHoleFactory extends GameFactory {
		
		private ChainReactionGame game = new ChainReactionGame();

		@Override
		public MultiplayerGame getGame() {
			return game;
		}
	}

	private static final int ANIM_SCHED_KEY = KEY_OPT_GUIDE;
		
	private PigeonHoleGameScreen _gameScreen;
	
	@Override
	protected GameLobby newGameLobby(Game app) {
		return new PigeonHoleLobby(app);
	}

	@Override
	public void joinGame(int gameID, boolean spectate) {
		
		_gameScreen = new PigeonHoleGameScreen(this);
		
		push(_gameScreen, TRANSITION_FORWARD, gameID);
		
	}
	
	void scheduleAnimation(Resource anim, int arg) {
		sendEvent(new HmeEvent.Key(getApp().getID(), KEY_REPEAT, PigeonHole.ANIM_SCHED_KEY, arg), anim);
	}

	
	public boolean handleEvent(HmeEvent event) {
		switch (event.getOpCode()) {
		case EVT_KEY:
			HmeEvent.Key e = (HmeEvent.Key)event;
			if (e.getAction() == KEY_REPEAT) {
				switch (e.getCode()) {
				case ANIM_SCHED_KEY:
				{
					if(getCurrentScreen() instanceof PigeonHoleGameScreen) {
						PigeonHoleGameScreen screen = (PigeonHoleGameScreen) getCurrentScreen();
						int arg = (int) e.getRawCode();
						screen.processAnim(arg);
					}
					return true;
				}
//				case LOBBY_UPDATE_KEY: {
//					int arg = (int) e.getRawCode();
//					int lobbyUpdateTime = processLobbyUpdate(arg);
//					//...repeat
//					if(_stopLobbyUpdate) {
////						_stopLobbyUpdate = false;
//						return true;
//					}
//					if(lobbyUpdateTime <= 0) {
//						lobbyUpdateTime = LOBBY_UPDATE_TIME_DEFAULT;
//					}
//					scheduleLobbyUpdate(arg, lobbyUpdateTime);
//					return true;
//				}
				}
			}
			break;
		}
		return super.handleEvent(event);
	}


	
}
