package com.blackledge.david.tivo.game.cribbage;

import com.blackledge.david.game.CardStack;
import com.blackledge.david.game.MultiplayerGame;
import com.blackledge.david.game.PlayerState;
import com.blackledge.david.game.cribbage.CribbageGame;
import com.blackledge.david.game.cribbage.CribbageGame.CribbageGameData;

import com.blackledge.david.tivo.game.Game;
import com.blackledge.david.tivo.game.GameLobby;

public class Cribbage extends Game {

	public static class CribbageFactory extends GameFactory {
		
		private CribbageGame game = new CribbageGame();

		public CardStack getCribCards(int gameID) {
			return game.getCardStack(gameID, CribbageGame.CRIB_ROW);
		}
		public CardStack getPlayCards(int gameID) {
			return game.getCardStack(gameID, CribbageGame.PLAY_ROW);
		}
		public CardStack getPlayerCards(int gameID, PlayerState player) {
			int row = game.getPlayerHandRow(player);
			return game.getCardStack(gameID, row);
		}

		@Override
		public MultiplayerGame getGame() {
			return game;
		}

		
//		//NOTE interprets negatives as facedown
//		public CardStack getCardStack(int gameID, int cardRow) {
//			return getGameBoard(gameID).getCards(cardRow);
//		}
//		//NOTE interprets facedown to negative
//		public void setCardStack(int gameID, int cardRow, CardStack stack) {
//			getGameBoard(gameID).setCards(cardRow, stack);
//		}
//
//		protected void removePlayer(GameData game, PlayerState player) {
//			// FIXME If game in progress, SAVE GAME or forfeit game
//			// FIXME if game not in progress we'll just wait for somebody else.
	}
	
	private CribbageGameScreen _gameScreen;
	
	@Override
	protected GameLobby newGameLobby(Game app) {
		return new CribbageLobby(app);
	}

	@Override
	public void joinGame(int gameID, boolean spectate) {
		
		_gameScreen = new CribbageGameScreen(this);
		
		push(_gameScreen, TRANSITION_FORWARD, gameID);
		
	}

	public boolean isGameWon() {
		if (getGameID() < 0)
			return false;
		CribbageGame cribbageGame = (CribbageGame) ((CribbageFactory) getFactory()).getGame();
		return cribbageGame.isGameWon((CribbageGameData) cribbageGame.getGameData(getGameID()));
	}

	
}
