package com.blackledge.david.tivo.net;


import java.io.IOException;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.net.InetAddress;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.List;
import java.util.logging.Logger;

import javax.jmdns.JmDNS;
//FIXME for compatibility with old hme sample server, needs to not link ServiceEvent in.
import javax.jmdns.ServiceEvent;
import javax.jmdns.ServiceInfo;
import javax.jmdns.ServiceListener;

public class TivoFinder {
    Logger _log = Logger.getLogger( this.getClass().getName() );
    
    public static final String SERVICE_TYPE_TIVO_HME = "_tivo-hme._tcp";
    public static final String SERVICE_TYPE_TIVO_VIDEOS = "_tivo-videos._tcp";
    public static final String SERVICE_TYPE_TIVO_PHOTOS = "_tivo-photos._tcp";
    public static final String SERVICE_TYPE_TIVO_MUSIC = "_tivo-music._tcp";
    public static final String SERVICE_TYPE_TIVO_REMOTE = "_tivo-remote._tcp";

    public static void main(String[] args) {
        try {
            TivoFinder x = TivoFinder.getInstance(
//            		);
    		null, "192.168.0.20");
            		
//            		null, ".20.0.168.192.in-addr.arpa.");
//            		null, ".20.0.168.192.ip6.arpa.");
//            		"192.168.0.11",
//            		 ".11.0.168.192.in-addr.arpa.");
//            		null, ".www.mp3tunes.com.");
//            		"168.143.122.49",
//    		".49.122.143.168.in-addr.arpa.");// prepared and reversed for arpa style
//    		".0.122.143.168.in-addr.arpa.");// subnet masked
//            null, ".remote-168.143.122.49.local.");
//            		null, ".sjmedia01.tivo.com.");
//            		"204.176.49.116");
//            		".116.49.176.204.in-addr.arpa.");// prepared and reversed for arpa style
//            		".0.49.176.204.in-addr.arpa."); // subnet masked
//                    null, ".remote-204.176.49.116.local.");
            x._log.info("TIVOS "+x.getTivos());
            x._log.info("APPS "+x.getApplications());
            x.stopFinding();
        } catch(IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
    
//    private final class AppResolveListener implements ResolveListener {
//        public void serviceResolved(DNSSDService resolver, int flags, int ifIndex, String fullName, String hostName, int port, TXTRecord txtRecord) {
//        //                new TivoMachine(fullName, hostName, port, getHashMap(txtRecord));
//                        System.out.println(currentAppName+" resolved as:"+fullName+" / "+hostName+":"+port+" "+txtRecord);
//                        // flag the browslistener that the resolve is finished.
//                        currentAppName = null;
//                    }
//
//        private HashMap<String, String> getHashMap(TXTRecord txtRecord) {
//            HashMap<String, String> result = new HashMap<String, String>(txtRecord.size());
//            for(int i = 0 ; i < txtRecord.size(); ++i) {
//                result.put( txtRecord.getKey( i ), txtRecord.getValueAsString( i ) );
//            }
//            return result;
//        }
//
//        public void operationFailed(DNSSDService service, int errorCode) {
//            // TODO Auto-generated method stub
//            
//        }
//    }
    
    
    
    //JMDNS example...
//    import javax.jmdns.*;
//
//    static class SampleListener implements ServiceListener
//    {
//    public void addService(JmDNS jmdns, String type, String name)
//    {
//        System.out.println("ADD: " + jmdns.getServiceInfo(type, name));
//    }
//    public void removeService(JmDNS jmdns, String type, String name)
//    {
//        System.out.println("REMOVE: " + name);
//    }
//    public void resolveService(JmDNS jmdns, String type, String name, ServiceInfo info)
//    {
//        System.out.println("RESOLVED: " + info);
//    }
//    }
//
//    JmDNS jmdns = new JmDNS();
//    jmdns.addServiceListener("_http._tcp.local.", new SampleListener());
    

    class TivoResolveListener implements ServiceListener {

        public void addService(JmDNS browser, String regType, String serviceName) {
            System.out.println("found "+serviceName+" / "+regType);
            synchronized(this) {
                _tivosDone = false;
                ++_tivosResolving;
            }
            _jmdns.requestServiceInfo(regType, serviceName);
        }

        public void removeService(JmDNS browser, String type, String name) {
            synchronized(_tivos) {
                TivoMachine removeme = null;
                for(TivoMachine machine : _tivos) {
                    if(machine.getName().equals(name)) {
                        removeme = machine;
                        break;
                    }
                }
                if(removeme != null) {
                    _tivos.remove( removeme );
                }
            }
        }

        public void resolveService(JmDNS resolver, String type, String name, ServiceInfo info) {
            int port = info.getPort();
            String hostName = getHostName( info );
            
            
            synchronized(_tivos) {
                // in old JmDNS name passed in is qualified name (name + . + type)
                if(name.endsWith(type)) {
                    name = name.substring(0, name.length()-type.length()-1);
                }
                _tivos.add(new TivoMachine(name, hostName, port, getHashMap(info)));
            }
                info.getType();
                // FIXME gotta set tivosDone somehow!
                //FIXME fine
                _log.info(name +" resolved as:"+type+" / "+hostName+":"+port);
                synchronized(this) {
                    --_tivosResolving;
                    if(_tivosResolving == 0) {
                        _tivosDone = true;
                    }
                }
//                if( currentFlags == 2 ) {
//                    tivosDone = true;
//                   log.finer( "tivos done" );
//                } else
//                    log.finer( ""+flags );

            // flag the browslistener that the resolve is finished.
            name = null;
            //FIXME need to stop service?
//            resolver.stop();
        }

        //TODO ServiceEvent section
        public void serviceAdded(ServiceEvent event) {
            addService( event.getDNS(), event.getType(), event.getName() );
            // TODO Auto-generated method stub
            
        }

        public void serviceRemoved(ServiceEvent event) {
            removeService( event.getDNS(), event.getType(), event.getName() );
            // TODO Auto-generated method stub
            
        }

        public void serviceResolved(ServiceEvent event) {
            resolveService( event.getDNS(), event.getType(), event.getName(), event.getInfo() );
            // TODO Auto-generated method stub
            
        }
    }

    class TivoAppResolveListener implements ServiceListener {
        public void addService(JmDNS browser, String regType, String serviceName) {
            System.out.println("found "+serviceName+" / "+regType);
            
            synchronized(this) {
                _appsDone = false;
                ++_appsResolving;
            }
            _jmdns.requestServiceInfo(regType, serviceName);
        }

        public void removeService(JmDNS browser, String type, String name) {
            synchronized(_apps) {
                HMEApplication removeme = null;
                for(HMEApplication machine : _apps) {
                    if(machine.getName().equals(name)) {
                        removeme = machine;
                        break;
                    }
                }
                if(removeme != null) {
                    _apps.remove( removeme );
                }
            }
        }

        public void resolveService(JmDNS resolver, String type, String name, ServiceInfo info) {
            int port = info.getPort();
            String hostName = getHostName( info );
            
            // in old JmDNS name passed in is qualified name (name + . + type)
            if(name.endsWith(type)) {
                name = name.substring(0, name.length()-type.length()-1);
            }
            synchronized(_apps) {
                _apps.add(new HMEApplication(name, hostName, port, getHashMap( info )));
            }
                // FIXME gotta set appsDone somehow!
                //FIXME fine
                _log.info(name +" resolved as:"+type+" / "+hostName+":"+port);
                synchronized(this) {
                    --_appsResolving;
                    if(_appsResolving == 0) {
                        _appsDone = true;
                    }
                }
//                if( currentFlags == 2 ) {
//                    appsDone = true;
//                    log.finer( "apps done" );
//                } else
//                    log.finer( ""+flags );
            // flag the browslistener that the resolve is finished.
            name = null;
            //FIXME need to stop service?
//            resolver.stop();
        }

        //TODO ServiceEvent section        
        public void serviceAdded(ServiceEvent event) {
            addService( event.getDNS(), event.getType(), event.getName() );
            // TODO Auto-generated method stub
            
        }

        public void serviceRemoved(ServiceEvent event) {
            removeService( event.getDNS(), event.getType(), event.getName() );
            // TODO Auto-generated method stub
            
        }

        public void serviceResolved(ServiceEvent event) {
            resolveService( event.getDNS(), event.getType(), event.getName(), event.getInfo() );
            // TODO Auto-generated method stub
            
        }    
    }

//    public String currentType;
//    public String currentDomain;
//    public int currentFlags;

//    HashMap<String, String> getHashMap(TXTRecord txtRecord) {
//        HashMap<String, String> result = new HashMap<String, String>(txtRecord.size());
//        for(int i = 0 ; i < txtRecord.size(); ++i) {
//            result.put( txtRecord.getKey( i ), txtRecord.getValueAsString( i ) );
//        }
//        return result;
//    }
    HashMap<String, String> getHashMap(ServiceInfo info) {
        Enumeration names = info.getPropertyNames();
        HashMap<String, String> result = new HashMap<String, String>();
        while(names.hasMoreElements()) {
            String name = (String)names.nextElement();
            result.put( name, info.getPropertyString( name ) );
        }
        return result;
    }

//    private final class AppBrowseListener implements BrowseListener {
//        public void serviceFound(DNSSDService browser, int flags, int ifIndex, String serviceName, String regType, String domain) {
//            System.out.println("found "+serviceName+" / "+flags);
//            synchronized(TivoFinder.this) {
//                currentAppName = serviceName;
//                try {
//                    DNSSD.resolve( flags, ifIndex, serviceName, regType, domain, appresolver );
//                } catch(DNSSDException e) {
//                    // TODO Auto-generated catch block
//                    e.printStackTrace();
//                }
//                // wait for the resolve listener to report that resolution is done.
//                while(currentAppName != null) {
//                    Thread.yield();
//                }
//            }
//
//        }
//
//        public void serviceLost(DNSSDService browser, int flags, int ifIndex, String serviceName, String regType, String domain) {
//            // TODO Auto-generated method stub
//            
//        }
//
//        public void operationFailed(DNSSDService service, int errorCode) {
//            // TODO Auto-generated method stub
//            
//        }
//    }

    public static class TivoMachine extends HMEApplication {
        public URL getURL() {
            try {
                return new URL(getProtocol(),getHostName(),getPort(),getPath());
            } catch(MalformedURLException e) {
                return null;
            }
        }
        public TivoMachine(String name, String hostName, int port, HashMap txtRecord) {
            super( name, hostName, port, txtRecord );
        }
        public String getProtocol() {
            return txtRecord.get( "protocol" );
        }
        public String getSwversion() {
            return txtRecord.get("swversion");
        }
        public String getPlatform() {
            return txtRecord.get("platform");
        }
        public String getTSN() {
            return txtRecord.get("TSN");
        }
        /**
         * UnsupportedOperationException
         */
        public String getVersion() {
            throw new UnsupportedOperationException("'version' not available for tivo videos, only Swversion");
        }
    }
    
    public static class HMEApplication {
        public URL getURL() {
            try {
                return new URL("http",getHostName(),getPort(),getPath());
            } catch(MalformedURLException e) {
                return null;
            }
        }
        private final int port;
        protected final HashMap<String, String> txtRecord;
        private final String hostName;
        private final String name;

        public HMEApplication(String name, String hostName, int port, HashMap txtRecord) {
            this.name = name;
            this.hostName = hostName;
            this.port = port;
            this.txtRecord = txtRecord;
        }
        public String getHostName() {
//            if(hostName.endsWith(".local.")) {
//                return hostName.substring(0, hostName.length()-(".local.".length()));
//            }
            return this.hostName;
        }
        public String getHostAddress() {
            String ip;
            try {
                ip = InetAddress.getByName( hostName ).getHostAddress();
            } catch(UnknownHostException e) {
                // attempt to use workaround
                if( hostName.endsWith( ".local." ) ) {
                    ip = hostName.substring( 0, hostName.length() - ".local.".length() );
                } else {
                    ip = hostName;
                }
            }
            return ip;
        }
        public String getName() {
            return this.name;
        }
        public int getPort() {
            return this.port;
        }
        public String getPath() {
            return txtRecord.get( "path" );
        }
        public String getVersion() {
            return txtRecord.get("version");
        }
        
        public String toString()
        {
            return getName();
        }
    }
    
    List<TivoMachine> _tivos = Collections.synchronizedList( new ArrayList<TivoMachine>());
    boolean _tivosDone = true;
    int _tivosResolving = 0;
    List<HMEApplication> _apps = Collections.synchronizedList( new ArrayList<HMEApplication>());
    boolean _appsDone = true;
    int _appsResolving = 0;

    JmDNS _jmdns;

    private TivoResolveListener _tivoListener;

    private TivoAppResolveListener _appListener;

	private String network;

	private InetAddress inet;

    private static TivoFinder _tivoFinder;

    private TivoFinder() throws IOException {
    	this(null, ".local.");
    }
    
    private TivoFinder(String inet, String network) throws IOException {
    	if(inet != null) {
    		this.inet = InetAddress.getByName(inet);
    	}
    	this.network = network;
        if(isBonjourInstalled()) {
            findServices();
        } else {
            //FIXME request install
        }
    }
    
    private String getNetwork() {
    	//FIXME if it's all numeric, reverse the chunks
		if (!(this.network.startsWith(".") && this.network.endsWith("."))
				&& this.network.matches("[0-9.]+")) {
			String net = "";
			String[] chunks = this.network.split("\\.");
			for (int i = chunks.length - 1; i >= 0; --i) {
				String chunk = chunks[i];
				if (chunk.length() > 0)
					net += chunk + ".";
			}
			net += "in-addr.arpa.";
//System.out.println("ip " + this.network + " becomes " + net);
			return "." + net;
    	}
    	return this.network;
    }
    
    public static TivoFinder getInstance(String inet, String network) throws IOException {
        if(_tivoFinder == null) {
            _tivoFinder = new TivoFinder(inet, network);
        }
        return _tivoFinder;
    }
    
    public static TivoFinder getInstance() throws IOException {
        if(_tivoFinder == null) {
            _tivoFinder = new TivoFinder();
        }
        return _tivoFinder;
    }
    
//    public static class Service {
//
//         final int flags;
//         final int ifIndex;
//         final String serviceName;
//         final String regType;
//         final String domain;
//
//        public Service(int flags, int ifIndex, String serviceName, String regType, String domain) {
//            this.flags = flags;
//            // TODO Auto-generated constructor stub
//            this.ifIndex = ifIndex;
//            this.serviceName = serviceName;
//            this.regType = regType;
//            this.domain = domain;
//        }
//    }
//    String currentName;
//    String currentAppName;
//    protected ArrayList<Service> services = new ArrayList<Service>();
    
//    final ResolveListener appresolver = new AppResolveListener();
//    final ResolveListener tivoresolver = new TivoResolveListener();
    private void findServices() {
        try {
			getJmDNSInstance(InetAddress.getByName("192.168.0.20"));
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
//    	getJmDNSInstance();
        
        _tivoListener = new TivoResolveListener();
        _appListener = new TivoAppResolveListener();
System.out.println("listening to "+SERVICE_TYPE_TIVO_VIDEOS+getNetwork());
        _jmdns.addServiceListener(SERVICE_TYPE_TIVO_VIDEOS+getNetwork(), _tivoListener );
System.out.println("listening to "+SERVICE_TYPE_TIVO_HME+getNetwork());
        _jmdns.addServiceListener(SERVICE_TYPE_TIVO_HME+getNetwork(),  _appListener);
////        BrowseListener appbrowseListener = new AppBrowseListener();
//        BrowseListener browseListener = new TivoBrowseListener();
//        // TivoBrowseListener stops the browser DNSSDService when flags == 2
//        DNSSDService appBrowser = DNSSD.browse( 0, 0, SERVICE_TYPE_TIVO_HME, "", browseListener);
//        DNSSDService videoBrowser = DNSSD.browse( 0, 0, SERVICE_TYPE_TIVO_VIDEOS, "", browseListener);
//        //TODO can turn on all of them, but have to turn them off after a while and give up on finding anything.
////        DNSSDService musicBrowser = DNSSD.browse( 0, 0, SERVICE_TYPE_TIVO_MUSIC, "", browseListener);
////        DNSSDService photoBrowser = DNSSD.browse( 0, 0, SERVICE_TYPE_TIVO_PHOTOS, "", browseListener);
////        DNSSDService remoteBrowser = DNSSD.browse( 0, 0, SERVICE_TYPE_TIVO_REMOTE, "", browseListener);
        
        
//        appBrowser.stop();
//        
//        videoBrowser.stop();
    }

    private void getJmDNSInstance() {
        try {
            Method createMethod = JmDNS.class.getMethod( "create", (Class[]) null );
            _jmdns = (JmDNS)createMethod.invoke( null, (Object[]) null );
        } catch(SecurityException e) {
//            // TODO Auto-generated catch block
//            e.printStackTrace();
        } catch(NoSuchMethodException e) {
//            // TODO Auto-generated catch block
//            e.printStackTrace();
        } catch(IllegalArgumentException e) {
//            // TODO Auto-generated catch block
//            e.printStackTrace();
        } catch(IllegalAccessException e) {
//            // TODO Auto-generated catch block
//            e.printStackTrace();
        } catch(InvocationTargetException e) {
//            // TODO Auto-generated catch block
//            e.printStackTrace();
        }

        //                _jmdns = JmDNS.create();
        if(_jmdns == null) {
            Constructor<JmDNS> constructor;
            try {
                constructor = JmDNS.class.getConstructor( (Class[]) null);
                _jmdns = constructor.newInstance( (Object[]) null);
            } catch(IllegalArgumentException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            } catch(InstantiationException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            } catch(IllegalAccessException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            } catch(InvocationTargetException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            } catch(SecurityException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            } catch(NoSuchMethodException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
    }
    
    private void getJmDNSInstance(InetAddress inet) {
        try {
            Method createMethod = JmDNS.class.getMethod( "create", new Class<?>[] {InetAddress.class} );
            _jmdns = (JmDNS)createMethod.invoke( null, new Object[] {inet} );
        } catch(SecurityException e) {
//            // TODO Auto-generated catch block
//            e.printStackTrace();
        } catch(NoSuchMethodException e) {
//            // TODO Auto-generated catch block
//            e.printStackTrace();
        } catch(IllegalArgumentException e) {
//            // TODO Auto-generated catch block
//            e.printStackTrace();
        } catch(IllegalAccessException e) {
//            // TODO Auto-generated catch block
//            e.printStackTrace();
        } catch(InvocationTargetException e) {
//            // TODO Auto-generated catch block
//            e.printStackTrace();
        }

        //                _jmdns = JmDNS.create();
        if(_jmdns == null) {
            Constructor<JmDNS> constructor;
            try {
                constructor = JmDNS.class.getConstructor( new Class<?>[] {InetAddress.class});
                _jmdns = constructor.newInstance( new Object[] {inet});
            } catch(IllegalArgumentException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            } catch(InstantiationException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            } catch(IllegalAccessException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            } catch(InvocationTargetException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            } catch(SecurityException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            } catch(NoSuchMethodException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
    }
    
    /**
     * Call this to stop listening for changes to the apps or tivos lists and
     * end the related thread(s). This TivoFinder will be invalid and behavior
     * is undefined if you attempt to call any further methods.
     */
    public void stopFinding() {
      
        // old jmdns format
//        _jmdns.removeServiceListener( _tivoListener );
//        _jmdns.removeServiceListener( _appListener );
    	
    	// new jmdns throws IOExceptino
//        try {
			_jmdns.close();
//		} catch (IOException e) {
//			// FIXME latest version throws this... what should we do with it?
//			e.printStackTrace();
//		}
        _jmdns = null;
    }

    public static boolean isBonjourInstalled() {
        //FIXME add appropriate JmDNS one
//        try {
//            Class.forName( "com.apple.dnssd.DNSSD" );
//        } catch(ClassNotFoundException e) {
//            return false;
//        } finally {}
        return true;
    }
    
    public Collection<TivoMachine> getTivos() {
        do {
            try {
                Thread.sleep(2500);
            } catch(InterruptedException e) {
                break;
            }
        } while( !_tivosDone );
        // once first one was found, give it a little longer, then return
        try {
            Thread.sleep( 1000 );
        } catch(InterruptedException e) {
            // just continue.
        }
        return _tivos;
    }
    public Collection<HMEApplication> getApplications() {
        do {
            try {
                Thread.sleep(250);
            } catch(InterruptedException e) {
                break;
            }
        } while( !_appsDone );
        // once first one was found, give it a little longer, then return
        try {
            Thread.sleep( 1000 );
        } catch(InterruptedException e) {
            // just continue.
        }
        return _apps;
    }

    String getHostName(ServiceInfo info) {
        String hostName = null;
        
        
        Method method = null;
//          String hostName = info.getHostAddress();
        try {
            method = info.getClass().getMethod( "getHostAddress", (Class[])null );
        } catch(SecurityException e) {
//            // TODO Auto-generated catch block
//            e.printStackTrace();
        } catch(NoSuchMethodException e) {
//            // TODO Auto-generated catch block
//            e.printStackTrace();
        }
        if(method == null) {
            try {
                method = info.getClass().getMethod( "getAddress", (Class[])null );
            } catch(SecurityException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            } catch(NoSuchMethodException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
        if(method != null) {
            try {
                hostName = (String)method.invoke( info, (Object[])null );
            } catch(IllegalArgumentException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            } catch(IllegalAccessException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            } catch(InvocationTargetException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
        return hostName;
    }
    
    

}
